package html_editor_pro_5_1;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.net.*;
import java.lang.*;
import java.awt.Color;
import java.awt.Font;
import java.awt.datatransfer.*;
import javax.swing.BoxLayout;
import javax.swing.filechooser.*;

public class Editor extends JFrame  implements ActionListener, MouseListener, ClipboardOwner, KeyListener
{

  //Elementi del menu
  JMenuItem nuovoItem = new JMenuItem("Nuovo (HTML)");
  JMenuItem nuovoTxtItem = new JMenuItem("Nuovo (testo)");
  JMenuItem apriitem = new JMenuItem("Apri");
  JMenuItem salvaitem = new JMenuItem("Salva");
  JMenuItem salvaConNomeItem = new JMenuItem("Salva con nome...");
  JMenuItem esciitem = new JMenuItem("Esci");
  JMenuItem guidaitem = new JMenuItem("Guida");
  JMenuItem aboutitem = new JMenuItem("About...");
  JMenuItem replitem = new JMenuItem("AlexMfM's (J)Repeater");
  JRadioButtonMenuItem motif_rbm = new JRadioButtonMenuItem("CDE/Motif");
  JRadioButtonMenuItem win_rbm = new JRadioButtonMenuItem("Windows");
  JRadioButtonMenuItem metal_rbm = new JRadioButtonMenuItem("Metal");
  JMenuItem arialitem = new JMenuItem("Arial");
  JMenuItem timesitem = new JMenuItem("Times New Roman");
  JMenuItem courieritem = new JMenuItem("Courier");
  JMenuItem dialogitem = new JMenuItem("Dialog");
  JMenuItem caraSpecItem = new JMenuItem("Caratteri speciali...");
  JCheckBoxMenuItem wrapCkbItem = new JCheckBoxMenuItem("A capo automatico");
  JMenuItem cssEditorItem = new JMenuItem("AlexMfM's (J)CSS Editor");

  //Bottoni della toolbar
  JButton apri_bot = new JButton("Apri");
  JButton salva_bot = new JButton("Salva");
  JButton nuovo_bot = new JButton("New");
  JButton body_bot = new JButton("Body");
  JButton spazio_bot = new JButton("&nbsp");
  JButton min_bot = new JButton("<");
  JButton magg_bot = new JButton(">");
  JButton agrave_bot = new JButton("");
  JButton egrave_bot = new JButton("");
  JButton igrave_bot = new JButton("");
  JButton ograve_bot = new JButton("");
  JButton ugrave_bot = new JButton("");
  JButton eacute_bot = new JButton("");
  JButton link_bot = new JButton("<a>");
  JButton ogg_bot = new JButton("div");
  JButton js_bot = new JButton("js");
  JButton f_face_bot = new JButton("font");
  JButton comm_bot = new JButton("<!--");
  JButton br_bot = new JButton("br");
  JButton table_bot = new JButton("table");
  JButton img_bot = new JButton("img");
  JButton center_bot = new JButton("center");
  JButton ol_bot = new JButton("Liste");
  JButton ul_bot = new JButton("hr");

  //Il replicatore di codice
  Repl repeater = new Repl("AlexMfM's (J)Repeater for (J)Editor Ver 0.8 - Build 77");
  //L'editor css
  cssEditor editorCss = new cssEditor("AlexMfM's (J)CssEditor 0.1 for HTML (J)Editor 5.1");


  //Textarea per l'editing
  static JTextArea area_editing = new JTextArea("",50,50);
  //Statusbar
  JTextField statusbar = new JTextField("Ready");
  static LookAndFeel dimmi_laf;

  //Messo qui perche' cosi' il keyPressed lo vede
  JMenu file = new JMenu("File");
  JMenu guida = new JMenu("Help");
  JMenu tools = new JMenu("Tools");
  JMenu lef_menu = new JMenu("Look&Feel");
  //Messo qui perche' cosi' il mouseEntered lo vede
  JMenu fontsMenu = new JMenu("Fonts");

  public Editor(String titolo)
  {
   super(titolo);
   //Imposto dimensioni e posizione dell'editor css, ma NON lo mostra finche' non richiesto
   editorCss.setSize(600,500);
   editorCss.move((int)((Toolkit.getDefaultToolkit().getScreenSize().getWidth()/2)-(600/2)),(int)((Toolkit.getDefaultToolkit().getScreenSize().getHeight()/2)-(500/2)));
   editorCss.setTitle("AlexMfM's (J)CssEditor Ver 0.1 for HTML (J)Editor 5.1");

   //Qui vanno messi i componenti, layout e pannelli
   JPanel content_p = new JPanel();
   BorderLayout lay = new BorderLayout();

   content_p.setLayout(lay);

   //Elementi da aggiungere al pannello principale
   //Barra menu
   JPanel b_menu = new JPanel();
   b_menu.setLayout(new BorderLayout());

   JMenuBar barra_menu = new JMenuBar();
   //Imposto i tasti rapidi Alt+x per i menu.
   file.setMnemonic('f');
   guida.setMnemonic('h');
   tools.setMnemonic('t');
   fontsMenu.setMnemonic('o');
   lef_menu.setMnemonic('l');
   nuovoItem.setMnemonic('n');
   nuovoTxtItem.setMnemonic('u');
   apriitem.setMnemonic('a');
   salvaitem.setMnemonic('s');
   salvaConNomeItem.setMnemonic('v');
   esciitem.setMnemonic('e');
   replitem.setMnemonic('r');
   motif_rbm.setMnemonic('c');
   win_rbm.setMnemonic('w');
   metal_rbm.setMnemonic('m');
   guidaitem.setMnemonic('g');
   aboutitem.setMnemonic('b');
   arialitem.setMnemonic('a');
   timesitem.setMnemonic('t');
   courieritem.setMnemonic('c');
   dialogitem.setMnemonic('d');
   caraSpecItem.setMnemonic('s');
   wrapCkbItem.setMnemonic('a');
   cssEditorItem.setMnemonic('c');


   barra_menu.add(file);
   barra_menu.add(tools);
   barra_menu.add(lef_menu);
   barra_menu.add(guida);
   file.add(nuovoItem);
   file.add(nuovoTxtItem);
   file.add(apriitem);
   file.add(salvaitem);
   file.add(salvaConNomeItem);
   file.add(esciitem);
   guida.add(guidaitem);
   guida.add(aboutitem);
   tools.add(replitem);
   tools.add(cssEditorItem);
   tools.add(fontsMenu);
   tools.add(caraSpecItem);
   tools.add(wrapCkbItem);
   fontsMenu.add(arialitem);
   fontsMenu.add(timesitem);
   fontsMenu.add(courieritem);
   fontsMenu.add(dialogitem);
   lef_menu.add(motif_rbm);
   lef_menu.add(win_rbm);
   lef_menu.add(metal_rbm);
   b_menu.add(barra_menu);

   //Applico i colori ai bottoni
   apri_bot.setBackground(new Color(59,88,65));
   apri_bot.setForeground(new Color(255,255,255));
   salva_bot.setBackground(new Color(63,103,70));
   salva_bot.setForeground(new Color(255,255,255));
   nuovo_bot.setBackground(new Color(64,116,74));
   nuovo_bot.setForeground(new Color(255,255,255));
   body_bot.setBackground(new Color(64,130,77));
   body_bot.setForeground(new Color(255,255,255));
   spazio_bot.setBackground(new Color(66,148,81));
   spazio_bot.setForeground(new Color(255,255,255));
   min_bot.setBackground(new Color(63,163,82));
   min_bot.setForeground(new Color(255,255,255));
   magg_bot.setBackground(new Color(57,175,80));
   magg_bot.setForeground(new Color(0,0,0));
   agrave_bot.setBackground(new Color(51,188,76));
   agrave_bot.setForeground(new Color(0,0,0));
   egrave_bot.setBackground(new Color(41,201,71));
   egrave_bot.setForeground(new Color(0,0,0));
   igrave_bot.setBackground(new Color(30,213,64));
   igrave_bot.setForeground(new Color(0,0,0));
   ograve_bot.setBackground(new Color(17,233,58));
   ograve_bot.setForeground(new Color(0,0,0));
   ugrave_bot.setBackground(new Color(0,255,48));
   ugrave_bot.setForeground(new Color(0,0,0));
   eacute_bot.setBackground(new Color(59,88,65));
   eacute_bot.setForeground(new Color(255,255,255));
   link_bot.setBackground(new Color(63,103,70));
   link_bot.setForeground(new Color(255,255,255));
   ogg_bot.setBackground(new Color(64,116,74));
   ogg_bot.setForeground(new Color(255,255,255));
   js_bot.setBackground(new Color(64,130,77));
   js_bot.setForeground(new Color(255,255,255));
   f_face_bot.setBackground(new Color(66,148,81));
   f_face_bot.setForeground(new Color(255,255,255));
   comm_bot.setBackground(new Color(63,163,82));
   comm_bot.setForeground(new Color(255,255,255));
   br_bot.setBackground(new Color(57,175,80));
   br_bot.setForeground(new Color(0,0,0));
   table_bot.setBackground(new Color(51,188,76));
   table_bot.setForeground(new Color(0,0,0));
   img_bot.setBackground(new Color(41,201,71));
   img_bot.setForeground(new Color(0,0,0));
   center_bot.setBackground(new Color(30,213,64));
   center_bot.setForeground(new Color(0,0,0));
   ol_bot.setBackground(new Color(17,233,58));
   ol_bot.setForeground(new Color(0,0,0));
   ul_bot.setBackground(new Color(0,255,48));
   ul_bot.setForeground(new Color(0,0,0));



   //Toolbar con i bottoncini
   //Aggiungo i bottoni alla toolbar e faccio in modo che al passaggio
   //del mouse sopra ognuno, la statusbar cambi scritta
   JPanel t_bar = new JPanel();
   t_bar.setLayout(new GridLayout(2,11));
   t_bar.add(apri_bot);
   t_bar.add(salva_bot);
   t_bar.add(nuovo_bot);
   t_bar.add(body_bot);
   t_bar.add(spazio_bot);
   t_bar.add(min_bot);
   t_bar.add(magg_bot);
   t_bar.add(agrave_bot);
   t_bar.add(egrave_bot);
   t_bar.add(igrave_bot);
   t_bar.add(ograve_bot);
   t_bar.add(ugrave_bot);
   t_bar.add(eacute_bot);
   t_bar.add(link_bot);
   t_bar.add(ogg_bot);
   t_bar.add(js_bot);
   t_bar.add(f_face_bot);
   t_bar.add(comm_bot);
   t_bar.add(br_bot);
   t_bar.add(table_bot);
   t_bar.add(img_bot);
   t_bar.add(center_bot);
   t_bar.add(ol_bot);
   t_bar.add(ul_bot);

   //Pannello che unisce barramenu e toolbar
   JPanel strumenti = new JPanel();
   strumenti.setLayout(new BorderLayout());
   strumenti.add("North", b_menu);
   strumenti.add("South", t_bar);

   //Textarea
   JPanel t_area = new JPanel();
   //Lo scrollPane che ha come argomento la textarea serve per scrollare
   JScrollPane scrl = new JScrollPane(area_editing);

   wrapCkbItem.setSelected(true);
   t_area.setLayout(new BorderLayout());
   area_editing.setEditable(true);
   area_editing.setLineWrap(true);
   area_editing.addKeyListener(this);
   t_area.add(scrl);


   //Statusbar
   JPanel stat_bar = new JPanel();
   stat_bar.setLayout(new BorderLayout());
   statusbar.setEditable(false);
   stat_bar.add(statusbar);

   //Aggiungo i componenti al content_p
   content_p.add("North", strumenti);
   content_p.add("Center", t_area);
   content_p.add("South", stat_bar);


   //Qui vanno messi i listeners
   //Sono messi in ordine per componente
   //this.addKeyListener(this);

   //------
   //ActionListeners e acceleratori per la barra menu
   nuovoItem.addActionListener(this);
   nuovoItem.setAccelerator(KeyStroke.getKeyStroke('N', KeyEvent.CTRL_MASK));
   nuovoTxtItem.addActionListener(this);
   nuovoTxtItem.setAccelerator(KeyStroke.getKeyStroke('T', KeyEvent.CTRL_MASK));
   apriitem.addActionListener(this);
   apriitem.setAccelerator(KeyStroke.getKeyStroke('O', KeyEvent.CTRL_MASK));
   salvaitem.addActionListener(this);
   salvaitem.setAccelerator(KeyStroke.getKeyStroke('S', KeyEvent.CTRL_MASK));
   salvaConNomeItem.addActionListener(this);
   salvaConNomeItem.setAccelerator(KeyStroke.getKeyStroke('S', KeyEvent.CTRL_MASK+KeyEvent.SHIFT_MASK));
   esciitem.addActionListener(this);
   esciitem.setAccelerator(KeyStroke.getKeyStroke('Q', KeyEvent.CTRL_MASK));
   guidaitem.addActionListener(this);
   guidaitem.setAccelerator(KeyStroke.getKeyStroke('G', KeyEvent.CTRL_MASK));
   aboutitem.addActionListener(this);
   aboutitem.setAccelerator(KeyStroke.getKeyStroke('A', KeyEvent.CTRL_MASK));
   replitem.addActionListener(this);
   motif_rbm.addActionListener(this);
   win_rbm.addActionListener(this);
   metal_rbm.addActionListener(this);
   arialitem.addActionListener(this);
   timesitem.addActionListener(this);
   courieritem.addActionListener(this);
   dialogitem.addActionListener(this);
   caraSpecItem.addActionListener(this);
   wrapCkbItem.addActionListener(this);
   cssEditorItem.addActionListener(this);

   //ActionListeners per i bottoni ('zzo quanti sono!)
   apri_bot.addActionListener(this);
   salva_bot.addActionListener(this);
   nuovo_bot.addActionListener(this);
   body_bot.addActionListener(this);
   spazio_bot.addActionListener(this);
   min_bot.addActionListener(this);
   magg_bot.addActionListener(this);
   agrave_bot.addActionListener(this);
   egrave_bot.addActionListener(this);
   igrave_bot.addActionListener(this);
   ograve_bot.addActionListener(this);
   ugrave_bot.addActionListener(this);
   eacute_bot.addActionListener(this);
   link_bot.addActionListener(this);
   ogg_bot.addActionListener(this);
   js_bot.addActionListener(this);
   f_face_bot.addActionListener(this);
   comm_bot.addActionListener(this);
   br_bot.addActionListener(this);
   table_bot.addActionListener(this);
   img_bot.addActionListener(this);
   center_bot.addActionListener(this);
   ol_bot.addActionListener(this);
   ul_bot.addActionListener(this);

   //ActionListeners per i frame immissione tag
   conf_bd.addActionListener(this);
   ann_bd.addActionListener(this);
   ins_link_conf.addActionListener(this);
   ins_link_ann.addActionListener(this);
   ok_font_but.addActionListener(this);
   an_font_but.addActionListener(this);
   ok_img_but.addActionListener(this);
   an_img_but.addActionListener(this);
   ok_tab_but.addActionListener(this);
   an_tab_but.addActionListener(this);
   col_larg_ckb.addActionListener(this);

   //MouseListeners per i bottoni ('zzo quanti sono!)
   apri_bot.addMouseListener(this);
   salva_bot.addMouseListener(this);
   nuovo_bot.addMouseListener(this);
   body_bot.addMouseListener(this);
   spazio_bot.addMouseListener(this);
   min_bot.addMouseListener(this);
   magg_bot.addMouseListener(this);
   agrave_bot.addMouseListener(this);
   egrave_bot.addMouseListener(this);
   igrave_bot.addMouseListener(this);
   ograve_bot.addMouseListener(this);
   ugrave_bot.addMouseListener(this);
   eacute_bot.addMouseListener(this);
   link_bot.addMouseListener(this);
   ogg_bot.addMouseListener(this);
   js_bot.addMouseListener(this);
   f_face_bot.addMouseListener(this);
   comm_bot.addMouseListener(this);
   br_bot.addMouseListener(this);
   table_bot.addMouseListener(this);
   img_bot.addMouseListener(this);
   center_bot.addMouseListener(this);
   ol_bot.addMouseListener(this);
   ul_bot.addMouseListener(this);
   //MouseListeners per la barra menu
   apriitem.addMouseListener(this);
   salvaitem.addMouseListener(this);
   esciitem.addMouseListener(this);
   guidaitem.addMouseListener(this);
   aboutitem.addMouseListener(this);
   replitem.addMouseListener(this);
   motif_rbm.addMouseListener(this);
   win_rbm.addMouseListener(this);
   metal_rbm.addMouseListener(this);
   nuovoItem.addMouseListener(this);
   nuovoTxtItem.addMouseListener(this);
   salvaConNomeItem.addMouseListener(this);
   fontsMenu.addMouseListener(this);
   arialitem.addMouseListener(this);
   timesitem.addMouseListener(this);
   dialogitem.addMouseListener(this);
   courieritem.addMouseListener(this);
   caraSpecItem.addMouseListener(this);
   wrapCkbItem.addMouseListener(this);
   cssEditorItem.addMouseListener(this);


   //Imposto il content_pane
   setContentPane(content_p);
   content_p.setVisible(true);

   //Il seguente codice serve per "leggere" il LookAndFeel predefinito
   //e impostare correttamente il checkbox del menu relativo ai L&F

   dimmi_laf = UIManager.getLookAndFeel();
   if(dimmi_laf.getName()=="Windows")
   {win_rbm.setSelected(true);}
   else if(dimmi_laf.getName()=="CDE/Motif")
   {motif_rbm.setSelected(true);}
   else if(dimmi_laf.getName()=="Metal")
   {metal_rbm.setSelected(true);}


  }

  public static void main (String[] args)
  {
   JFrame edtr = new Editor("HTML (J)Editor Pro Ver 5.1 - Build 592");
   WindowListener wl = new WindowAdapter()
   {public void windowClosing(WindowEvent e){System.exit(0);}};
   edtr.addWindowListener(wl);
   edtr.setSize(800,550);
   edtr.setVisible(true);
     
   try {
        UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
        edtr.validate();
       }
   catch (Exception e)
   {
    JOptionPane.showMessageDialog(null,"Impossibile impostare lo stile: " + e);

   //Se non va con il metal si fa prendere il L&F di sistema.
   //Occorre un blocco try...catch interno!!!
   try{
   UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
   }
   catch (Exception e_int)
   {
    JOptionPane.showMessageDialog(null,"Impossibile impostare lo stile: " + e_int);
   }
   //Fine blocco try...catch interno
      }

   area_editing.requestFocus();


  }//Fine main()

  

  public void keyPressed(KeyEvent ke)
  {
   /*Idea per implementare il corretto utilizzo dei mnemonics:
     creare boolean altPremuto, inizializz a false. Quando arriva
     il codice virtuale VK_ALT cambiare il valore di altPremuto
     nel suo opposto. Poi check su carattere premuto. Se il char
     e' giusto e la var e' true, allora implementa codice.
     In keyReleased mettere che se arriva il codice virtuale per
     l'alt, la var altPremuto ritorna a false.
   */
   }

  
  public void keyTyped(KeyEvent ke)
  {}

  public void keyReleased(KeyEvent ke)
  {}

  

  String buffer_x_repeater = new String();
  int cont_ar=0;
  String buffer_x_font = new String("<font ");
  String buffer_x_img = new String("<img ");
  String buffer_x_tab = new String("<table ");
  LookAndFeel laf_att;
  boolean tab_flipflop= false;
  int numcols=0;
  int totcols;
  String nomeFileCorrente = new String("Untitled");


  public void actionPerformed(ActionEvent evento)
 {
  //Finisce alla riga 1329  - N.d.P :-)
  Object sorgente = evento.getSource();

  if(sorgente==esciitem)
  {
   int decisione = JOptionPane.showConfirmDialog(null,
   "Salvare il documento corrente prima di uscire dall'applicazione?",
   "Salvo il documento?", JOptionPane.YES_NO_CANCEL_OPTION);

   if (decisione==JOptionPane.YES_OPTION)
   { funzione_salva();
     System.exit(0);
   }
   else if (decisione==JOptionPane.NO_OPTION)
   {
   System.exit(0);
   }
   else if (decisione==JOptionPane.CANCEL_OPTION)
   {
   return;
   }

  }

  if ((sorgente==apriitem)||(sorgente==apri_bot))
  {
   //JOptionPane.showMessageDialog(null, "Funzione 'Apri' non ancora disponibile");

   apriitem.setArmed(false);
   leggi();
  }

  if(sorgente==salvaConNomeItem)
  {
   salvaConNomeItem.setArmed(false);
   funzione_salvaConNome();
  }

  if ((sorgente==salvaitem)||(sorgente==salva_bot))
  {
   //JOptionPane.showMessageDialog(null, "Funzione 'Salva' non ancora disponibile");
   salvaitem.setArmed(false);
   funzione_salva();

  }

  if(sorgente==guidaitem)
  {
   //JOptionPane.showMessageDialog(null, "Funzione 'Guida' non ancora disponibile");
   guidaitem.setArmed(false);
   mostra_guida();
  }

  if(sorgente==aboutitem)
  {
  //JOptionPane.showMessageDialog(null, "Funzione 'About' non ancora disponibile");
   mostra_about();
  }

  if(sorgente==replitem)
  {
   //JOptionPane.showMessageDialog(null, "Pulsante repeater");
   //Prendo la posizione del cursore. Se poi serve la riutilizzo
   //per reindirizzare la parte copiata all'area di testo dell'editor.
   int cursore = area_editing.getCaretPosition();

   repeater.setSize(700,500);
   repeater.show();

   
  }

  //Tutti i pulsanti
  if((sorgente==nuovo_bot)||(sorgente==nuovoItem))
  {
  nuovoItem.setArmed(false);
  //JOptionPane.showMessageDialog(null, "Funzione 'Nuovo' non ancora disponibile");
  String titolo = new String("");
  titolo = JOptionPane.showInputDialog(null, "Inserire il titolo della nuova pagina:", "<title>...</title>", JOptionPane.QUESTION_MESSAGE);
   int ascii = titolo.hashCode();
    //JOptionPane.showMessageDialog(null, ""+titolo.hashCode());
   if(ascii!=0)
   {
    crea_nuovo();
    area_editing.grabFocus();
    area_editing.insert(titolo, 22);
    area_editing.setCaretPosition(22+titolo.length()+18);
    body_func();
   }
   if(titolo.hashCode()==0)
   {
    int no_title_resp;
    no_title_resp = JOptionPane.showConfirmDialog(null, "Non  stato immesso alcun titolo.\n"+
    "Procedo ugualmente?\n", "Titolo mancante", JOptionPane.YES_NO_CANCEL_OPTION);
    
     switch(no_title_resp)
     {
      case JOptionPane.YES_OPTION:
      crea_nuovo();
      area_editing.grabFocus();
      area_editing.insert(titolo, 22);
      area_editing.setCaretPosition(22+titolo.length()+18);
      body_func();

      case JOptionPane.NO_OPTION:
      case JOptionPane.CANCEL_OPTION:
      return;
     } 

   }
   statusbar.setText("Ready - Untitled");
   nomeFileCorrente="untitled";
  }

    if(sorgente==body_bot)
  {
  //JOptionPane.showMessageDialog(null, "Funzione 'Body' non ancora disponibile");
   int cursore = area_editing.getCaretPosition();
   //area_editing.insert("<body bgcolor=\"\" background=\"\" text=\"\" link=\"\" alink=\"\" vlink=\"\" bgproperties=\"fixed\">", cursore);
   body_func();
   area_editing.grabFocus();
   int cp = area_editing.getCaretPosition();
   area_editing.setCaretPosition(cp);
  }

  if(sorgente==spazio_bot)
  {
  //JOptionPane.showMessageDialog(null, "Funzione 'Spazio' non ancora disponibile");
   int cursore = area_editing.getCaretPosition();
   area_editing.insert("&nbsp;", cursore);
   area_editing.grabFocus();
  }

  if(sorgente==min_bot)
  {
  //JOptionPane.showMessageDialog(null, "Funzione 'Minore' non ancora disponibile");
   int cursore = area_editing.getCaretPosition();
   area_editing.insert("&lt;", cursore);
   area_editing.grabFocus();
  }

  if(sorgente==magg_bot)
  {
  //JOptionPane.showMessageDialog(null, "Funzione 'Maggiore' non ancora disponibile");
   int cursore = area_editing.getCaretPosition();
   area_editing.insert("&gt;", cursore);
   area_editing.grabFocus();
  }

  if(sorgente==agrave_bot)
  {
  //JOptionPane.showMessageDialog(null, "Funzione '' non ancora disponibile");
   int cursore = area_editing.getCaretPosition();
   area_editing.insert("&agrave;", cursore);
   area_editing.grabFocus();
  }

  if(sorgente==egrave_bot)
  {
  //JOptionPane.showMessageDialog(null, "Funzione '' non ancora disponibile");
   int cursore = area_editing.getCaretPosition();
   area_editing.insert("&egrave;", cursore);
   area_editing.grabFocus();
  }

  if(sorgente==igrave_bot)
  {
  //JOptionPane.showMessageDialog(null, "Funzione '' non ancora disponibile");
   int cursore = area_editing.getCaretPosition();
   area_editing.insert("&igrave;", cursore);
   area_editing.grabFocus();
  }

  if(sorgente==ograve_bot)
  {
  //JOptionPane.showMessageDialog(null, "Funzione '' non ancora disponibile");
   int cursore = area_editing.getCaretPosition();
   area_editing.insert("&ograve;", cursore);
   area_editing.grabFocus();
  }

  if(sorgente==ugrave_bot)
  {
  //JOptionPane.showMessageDialog(null, "Funzione '' non ancora disponibile");
   int cursore = area_editing.getCaretPosition();
   area_editing.insert("&ugrave;", cursore);
   area_editing.grabFocus();
  }

  if(sorgente==eacute_bot)
  {
  //JOptionPane.showMessageDialog(null, "Funzione '' non ancora disponibile");
   int cursore = area_editing.getCaretPosition();
   area_editing.insert("&eacute;", cursore);
   area_editing.grabFocus();
  }

  if(sorgente==link_bot)
  {
  //JOptionPane.showMessageDialog(null, "Funzione '<a>' non ancora disponibile");
   int cursore = area_editing.getCaretPosition();
   //area_editing.insert("<a href=\"\"></a>", cursore);
   imm_link();
   area_editing.grabFocus();
   int cp = area_editing.getCaretPosition();
   area_editing.setCaretPosition(cp-6);
  }

  if(sorgente==ogg_bot)
  {
  //JOptionPane.showMessageDialog(null, "Funzione '<div>' non ancora disponibile");
   int cursore = area_editing.getCaretPosition();
   area_editing.insert("<div id=\"\" style=\"\">\n\n</div>", cursore);
   area_editing.grabFocus();
   int cp = area_editing.getCaretPosition();
   area_editing.setCaretPosition(cp-19);
  }

  if(sorgente==js_bot)
  {
  //JOptionPane.showMessageDialog(null, "Funzione '<script>' non ancora disponibile");
   int cursore = area_editing.getCaretPosition();
   area_editing.insert("<script language=\"\">\n\n</script>", cursore);
   area_editing.grabFocus();
   int cp = area_editing.getCaretPosition();
   area_editing.setCaretPosition(cp-13);
  }

  if(sorgente==f_face_bot)
  {
  //JOptionPane.showMessageDialog(null, "Funzione '<font face='...'>' non ancora disponibile");

   /*
   //Vecchia funzione font_face

   int cursore = area_editing.getCaretPosition();
   area_editing.insert("<font face=\"\">", cursore);
   area_editing.grabFocus();
   int cp = area_editing.getCaretPosition();
   area_editing.setCaretPosition(cp-2);*/

   imposta_font();

  }

  if(sorgente==comm_bot)
  {
  //JOptionPane.showMessageDialog(null, "Funzione '<font color='...'' non ancora disponibile");
   int cursore = area_editing.getCaretPosition();
   area_editing.insert("<!--\n\n-->", cursore);
   area_editing.grabFocus();
   int cp = area_editing.getCaretPosition();
   area_editing.setCaretPosition(cp-4);
  }

  if(sorgente==br_bot)
  {
  //JOptionPane.showMessageDialog(null, "Funzione '<br>' non ancora disponibile");
   int cursore = area_editing.getCaretPosition();
   area_editing.insert("<br>", cursore);
   area_editing.grabFocus();
  }

  if(sorgente==table_bot)
  {
  //JOptionPane.showMessageDialog(null, "Funzione '<table>' non ancora disponibile");
   //Ex funzione di immissione tabella...
   /*
   int cursore = area_editing.getCaretPosition();
   area_editing.insert("<table style=\"\">\n<tr>\n<td>\n\n</td>\n</tr>\n</table>", cursore);
   area_editing.grabFocus();
   int cp = area_editing.getCaretPosition();
   area_editing.setCaretPosition(cp-34);*/

   funz_tabella();

  }

  if(sorgente==img_bot)
  {
  //JOptionPane.showMessageDialog(null, "Funzione '<img>' non ancora disponibile");
  // Ex funzione per immettere immagine senza nuovo frame
  /*
   int cursore = area_editing.getCaretPosition();
   area_editing.insert("<img src=\"\" alt=\"\">", cursore);
   area_editing.grabFocus();
   int cp = area_editing.getCaretPosition();
   area_editing.setCaretPosition(cp-9);
  */
  funz_img();
  }

  if(sorgente==center_bot)
  {
  //JOptionPane.showMessageDialog(null, "Funzione '<center>' non ancora disponibile");
   int cursore = area_editing.getCaretPosition();
   area_editing.insert("<center>\n\n</center>", cursore);
   area_editing.grabFocus();
   int cp = area_editing.getCaretPosition();
   area_editing.setCaretPosition(cp-10);
  }

  if(sorgente==ol_bot)
  {
  //JOptionPane.showMessageDialog(null, "Funzione '<ol>' non ancora disponibile");
   /*int cursore = area_editing.getCaretPosition();
   area_editing.insert("<ol>\n<li>\n\n</ol>", cursore);
   area_editing.grabFocus();
   int cp = area_editing.getCaretPosition();
   area_editing.setCaretPosition(cp-7);*/
   funz_liste();
  }

  if(sorgente==ul_bot)
  {
   //Mantengo la vecchia denominazione di ul_bot anche se
   //ora si occupa di linee orizzontali!!!
   int cursore = area_editing.getCaretPosition();
   area_editing.insert("<hr>", cursore);
   area_editing.grabFocus();
  }

  if(sorgente==conf_bd)
  {
  int cursore = area_editing.getCaretPosition();

  int cont_bd;
  String buffer_x_body = new String("<body ");

  for(cont_bd=0;cont_bd<7;cont_bd++)
    {
     //JOptionPane.showMessageDialog(null, "Testo:"+array_font_input[cont_ar].getText());

     if(body_ckb[cont_bd].isSelected())
     {
      buffer_x_body+=body_array_str[cont_bd]+body_input_array[cont_bd].getText()+"\" ";
      //JOptionPane.showMessageDialog(null, "Testo:"+array_font_input[cont_ar].getText());
     }

    }
    buffer_x_body+=">";
    //JOptionPane.showMessageDialog(null, buffer_x_font);

    if((body_ckb[0].isSelected()==false)&&
       (body_ckb[1].isSelected()==false)&&
       (body_ckb[2].isSelected()==false)&&
       (body_ckb[3].isSelected()==false)&&
       (body_ckb[4].isSelected()==false)&&
       (body_ckb[5].isSelected()==false)&&
       (body_ckb[6].isSelected()==false))
    {buffer_x_body="";}

    area_editing.insert(buffer_x_body, cursore);
    area_editing.grabFocus();


    buffer_x_body="<body ";




  /*area_editing.insert("<body bgcolor=\""+bg_field.getText()+"\" background=\""+
  back_field.getText()+"\" text=\""+text_field.getText()+"\" link=\""+link_field.getText()+
  "\" alink=\""+alink_field.getText()+"\" vlink=\""+vlink_field.getText()+
  "\" bgproperties=\"fixed\">", cursore);  */
   body_scelta.dispose();

  }
  if(sorgente==ann_bd)
  {
  body_scelta.dispose();
  }
  if(sorgente==ins_link_ann)
  {
   imm_link_frame.dispose();
  }
  if(sorgente==ins_link_conf)
  {
   //area_editing.insert("<a href=\""+lnk_field.getText()+"\" target=\""+tar_link_field.getText()+"\">"+txt_link_field.getText()+"</a>", cursr);
   //Chissa' perche' ma qui ci vuole questo +6, altrimenti mette la scritta
   //6 caratteri prima e succede un gran casino...
   int cursore = area_editing.getCaretPosition()+6;
   int cont_lnk=0;
  String buffer_x_link = new String("<a ");

  for(cont_lnk=0;cont_lnk<2;cont_lnk++)
  {
   if(link_array[cont_lnk].isSelected())
   {
    //JOptionPane.showMessageDialog(null, "Checkbox "+cont_lnk+" selezionato");
    buffer_x_link+=link_prop_nome[cont_lnk]+array_link_input[cont_lnk].getText()+"\" ";
   }
  }

  if(link_array[2].isSelected())
  {
   buffer_x_link+=">"+array_link_input[2].getText()+"</a";
  }

      buffer_x_link+=">";


    if((link_array[0].isSelected()==false)&&
       (link_array[1].isSelected()==false)&&
       (link_array[2].isSelected()==false))
    {buffer_x_link="";}

    area_editing.insert(buffer_x_link, cursore);
    area_editing.grabFocus();
    area_editing.setCaretPosition(cursore+buffer_x_link.length());


    buffer_x_link="<a ";


   imm_link_frame.dispose();
   area_editing.setCaretPosition(area_editing.getCaretPosition()+31);
   //La riga qui sopra serve perche' per un non so quale motivo, dopo aver
   //fatto il suo dovere, portava indietro il cursore di 31 posizioni
   //Chi se ne fotte! Cosi' funziona, chemmefrega?
  }
  if(sorgente==an_font_but)
  {
   frame_font.dispose();
  }
  if(sorgente==ok_font_but)
  {
   int cursore = area_editing.getCaretPosition();

   for(cont_ar=0;cont_ar<3;cont_ar++)
    {
     //JOptionPane.showMessageDialog(null, "Testo:"+array_font_input[cont_ar].getText());

     if(array_ck[cont_ar].isSelected())
     {
      buffer_x_font+=array_prop_font_nome[cont_ar]+array_font_input[cont_ar].getText()+"\" ";
      //JOptionPane.showMessageDialog(null, "Testo:"+array_font_input[cont_ar].getText());
     }

    }
    buffer_x_font+=">";
    //JOptionPane.showMessageDialog(null, buffer_x_font);

    if((array_ck[0].isSelected()==false)&&
       (array_ck[1].isSelected()==false)&&
       (array_ck[2].isSelected()==false))
    {buffer_x_font="";}

    area_editing.insert(buffer_x_font, cursore);
    area_editing.grabFocus();


    buffer_x_font="<font ";


   frame_font.dispose();
  }

   else if (sorgente==motif_rbm)
    {
     win_rbm.setSelected(false);
     metal_rbm.setSelected(false);
     //codice x impostare il motif
     try
     {
     UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
     }
     catch (Exception e)
     {JOptionPane.showMessageDialog(null, "Impossibile impostare lo stile: "+e);
     }
     statusbar.setText("Ready - "+nomeFileCorrente);
     SwingUtilities.updateComponentTreeUI(super);

    }



    else if (sorgente==win_rbm)
    {
     motif_rbm.setSelected(false);
     metal_rbm.setSelected(false);
     //codice x impostare il win

     try
     {
     //import javax.swing.plaf.multi.MultiLookAndFeel
      UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");

     }
     catch (Exception e)
     {JOptionPane.showMessageDialog(null, "Impossibile impostare lo stile: "+e);
     }

     statusbar.setText("Ready - "+nomeFileCorrente);
     SwingUtilities.updateComponentTreeUI(super);

    }

    else if (sorgente==metal_rbm)
    {
     motif_rbm.setSelected(false);
     win_rbm.setSelected(false);
     //codice x impostare il metal
     try
     {
      //import javax.swing.plaf.metal.MetalLookAndFeel
      UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
     }
     catch (Exception e)
     {JOptionPane.showMessageDialog(null, "Impossibile impostare lo stile: "+e);
     }
     statusbar.setText("Ready - "+nomeFileCorrente);
     SwingUtilities.updateComponentTreeUI(super);

    }

    if(sorgente==an_img_but)
   {
    frame_img.dispose();

   }
   if(sorgente==ok_img_but)
   {
     int cursore = area_editing.getCaretPosition();

   for(cont_ar=0;cont_ar<4;cont_ar++)
    {
     //JOptionPane.showMessageDialog(null, "Testo:"+array_font_input[cont_ar].getText());

     if(array_img[cont_ar].isSelected())
     {
      buffer_x_img+=array_img_nome[cont_ar]+array_img_input[cont_ar].getText()+"\" ";
      //JOptionPane.showMessageDialog(null, "Testo:"+array_font_input[cont_ar].getText());
     }

    }
    buffer_x_img+=">";
    //JOptionPane.showMessageDialog(null, buffer_x_font);

    if((array_img[0].isSelected()==false)&&
       (array_img[1].isSelected()==false)&&
       (array_img[2].isSelected()==false)&&
       (array_img[3].isSelected()==false))
    {buffer_x_img="";}

    area_editing.insert(buffer_x_img, cursore);
    area_editing.grabFocus();
    area_editing.setCaretPosition(cursore+buffer_x_img.length());


    buffer_x_font="<img ";


   frame_img.dispose();
   }

   if(sorgente==an_tab_but)
   {
    frame_tabella.dispose();
    int z;
    for(z=0;z<10;z++)
    {
     arr_tab_tgl[z].setEditable(false);
    }
    col_larg_ckb.setSelected(false);
    tab_flipflop=false;

   }

   if(sorgente==col_larg_ckb)
   {

    if((cols_field.getText().length()==0)||
    (Integer.parseInt(cols_field.getText())==0)||(Integer.parseInt(cols_field.getText())>10))
      {
      JOptionPane.showMessageDialog(null,"Attenzione!\n"+
      "Per poter immettere le dimensioni delle colonne e' necessario\n"+
      "impostare un numero di colonne valido (tra 1 e 10)", "Impossibile proseguire",
      JOptionPane.ERROR_MESSAGE);
      col_larg_ckb.setSelected(false);
      int z;
      for(z=0;z<10;z++)
      {
       arr_tab_tgl[z].setEditable(false);
      }
      col_larg_ckb.setSelected(false);
      tab_flipflop=false;
      cols_field.setText("");
     }

    if((tab_flipflop==false))
     {

      numcols = Integer.parseInt(cols_field.getText());
      for(totcols=0;totcols<numcols;totcols++)
      {
       arr_tab_tgl[totcols].setEditable(true);
      }


      tab_flipflop=true;
      numcols=0;
     }
     else if(tab_flipflop==true)
     {
      int z;
      for(z=0;z<10;z++)
      {
       arr_tab_tgl[z].setEditable(false);
      }
      col_larg_ckb.setSelected(false);
      tab_flipflop=false;
     }

   }

   if(sorgente==ok_tab_but)
   {
    //Inserire codice x creare tag tabella...
    int r; int c;
    int n_rows;
    int n_cols;
    String n_bord = new String("");
    String buffer_bordo = new String("border=\"");

    if(rows_field.getText().length()==0)
    {n_rows=1;}
    if(cols_field.getText().length()==0)
    {n_cols=1;}
    if(bord_field.getText().length()==0)
    {buffer_bordo=">";}
    if(rows_field.getText().length()!=0)
    {n_rows= Integer.parseInt(rows_field.getText());}
    if(cols_field.getText().length()!=0)
    {n_cols=Integer.parseInt(cols_field.getText());}
    if(bord_field.getText().length()!=0)
    {n_bord=bord_field.getText()+"\">\n";
     buffer_bordo+=n_bord;}
    //Sarebbe superfluo e si potrebbe fare tutto in fondo,
    //ma cosi' e' piu' chiaro quello che si fa.
    //Qui si mette in buffer l'inizio della tabella
    buffer_x_tab+=buffer_bordo;
    //Segue il codice per creare le celle

    //Il contenuto di buffer_bordo non ci serve piu' e
    //per non creare altre variabili la utilizzo per
    //la struttura della tabella
    buffer_bordo="";
    n_rows=Integer.parseInt(rows_field.getText());
    n_cols=Integer.parseInt(cols_field.getText());

    //For sulle righe
    for(r=0;r<n_rows;r++)
     {
      buffer_bordo+="<tr>\n";
     //For sulle colonne
     for(c=0;c<n_cols;c++)
      {
       //Se vengono indicate le dim delle celle...
       if(col_larg_ckb.isSelected())
       {
        buffer_bordo+="<td width=\""+arr_tab_tgl[c].getText()+"\">\n\n</td>\n";
       }
       //Se non vengono indicate...
       else
       buffer_bordo+="<td>\n\n</td>\n";

      } //Fine for sulle colonne
      buffer_bordo+="</tr>\n";
     }//Fine for sulle righe



    buffer_x_tab+=buffer_bordo+"</table>";

    //Controllo output:
    //JOptionPane.showMessageDialog(null,buffer_x_tab);

    int caret = area_editing.getCaretPosition();
    area_editing.insert(buffer_x_tab, caret);

    //Azzera tutto
    int z;
    for(z=0;z<10;z++)
    {
     arr_tab_tgl[z].setEditable(false);
     arr_tab_tgl[z].setText("");
    }
    col_larg_ckb.setSelected(false);
    tab_flipflop=false;
    rows_field.setText("");
    cols_field.setText("");
    bord_field.setText("");
    buffer_x_tab="<table ";
    frame_tabella.dispose();
   }

  if(sorgente==dispose_about_button)
  {
   about_frame.dispose();
  }

  if(sorgente==an_liste_but)
  {
   frame_liste.dispose();
  }

  if(sorgente==ok_liste_but)
  {
   int int_num_ogg=0;
   int_num_ogg = Integer.parseInt(tfield_num_punti.getText());
   if(int_num_ogg==0)
   {
    JOptionPane.showMessageDialog(null, "Attenzione, non e' stato specificato il numero degli\n"+
    "elementi della lista da creare. Specificare tale numero oppure\n"+
    "cliccare sul tasto 'Annulla'.", "Errore numero elementi da creare", JOptionPane.ERROR_MESSAGE);
    return;
   }

   int qualestile=0;

   String buffer_crea_oggetti = new String("");

   buffer_x_liste="<ol style='list-style-type:";

   if(cb_stili.isSelected()==true)
    {
     qualestile=combo_stile_liste.getSelectedIndex();
      //Switch su quale stile si e' scelto
      switch(qualestile)
      {
       case 0:
       buffer_x_liste+="disc'>";
       break;
       case 1:
       buffer_x_liste+="circle'>";
       break;
       case 2:
       buffer_x_liste+="square'>";
       break;
       case 3:
       buffer_x_liste+="decimal'>";
       break;
       case 4:
       buffer_x_liste+="lower-roman'>";
       break;
       case 5:
       buffer_x_liste+="upper-roman'>";
       break;
       case 6:
       buffer_x_liste+="lower-alpha'>";
       break;
       case 7:
       buffer_x_liste+="upper-alpha'>";
       break;
       case 8:
       //Uso un filechooser per scegliere l'immagine dal disco
       JFileChooser apri_box = new JFileChooser();
       apri_box.showOpenDialog(this);
       String file_da_aprire = apri_box.getSelectedFile().getPath();

       String trasf_url = new String("");
       int ultimo_fslash = 0;
       ultimo_fslash=file_da_aprire.lastIndexOf("\\")+1;
       //JOptionPane.showMessageDialog(null,"Ultimo \\:"+ultimo_fslash);
       trasf_url=file_da_aprire.substring(ultimo_fslash);
       //JOptionPane.showMessageDialog(null,"Url ridotto :"+trasf_url);

       buffer_x_liste="<ol style='list-style-image:"+trasf_url+"'>";
       break;
     };
    }

    if(cb_stili.isSelected()==false)
    {
     buffer_x_liste="<ol>";
    }
    
    buffer_x_liste+="\n";

    String buffer_x_oggetti = new String("");
    int k=0;
    for(k=0;k<int_num_ogg;k++)
    {
     buffer_x_oggetti+="<li>\n";
    }
    buffer_x_liste+=buffer_x_oggetti+"</ol>\n";

    //JOptionPane.showMessageDialog(null, buffer_x_liste);
    int cursore = area_editing.getCaretPosition();
    area_editing.insert(buffer_x_liste, cursore);
    area_editing.setCaretPosition(cursore);

  }

  if(sorgente==cb_stili)
  {
  //Verifica stato checkbox
   if(cb_stili.isSelected()==true)
    {
     combo_stile_liste.setEnabled(true);
     //JOptionPane.showMessageDialog(null, "OK");
    }
   if(cb_stili.isSelected()==false)
    {
     combo_stile_liste.setEnabled(false);
    }
  }

  if(sorgente==arialitem)
  {
   area_editing.setFont(new Font("Arial",area_editing.getFont().getStyle(), area_editing.getFont().getSize()));
   area_editing.repaint();
  }
  if(sorgente==timesitem)
  {
   area_editing.setFont(new Font("Times New Roman",area_editing.getFont().getStyle(), area_editing.getFont().getSize()));
   area_editing.repaint();
  }
  if(sorgente==courieritem)
  {
   area_editing.setFont(new Font("Courier",area_editing.getFont().getStyle(), area_editing.getFont().getSize()));
   area_editing.repaint();
  }
  if(sorgente==dialogitem)
  {
   area_editing.setFont(new Font("Dialog",area_editing.getFont().getStyle(), area_editing.getFont().getSize()));
   area_editing.repaint();
  }
  if(sorgente==caraSpecItem)
  {
   caraSpecItem.setArmed(false);
   funzioneCaraSpec();
  }
  if(sorgente==nuovoTxtItem)
  {
   area_editing.setText("");
   statusbar.setText("Ready - Untitled");
   nomeFileCorrente="untitled";
  }

  if(sorgente==wrapCkbItem)
  {
   //Da falso se era selezionato e si clicca.
   //Da vero se era deselezionato e si clicca.
   //Sembra ragionare al contrario ma e' giusto.
   if(!wrapCkbItem.isSelected())
   {
    area_editing.setLineWrap(false);
   }
   else if(wrapCkbItem.isSelected())
   {
    area_editing.setLineWrap(true);
   }
  }
  if(sorgente==cssEditorItem)
  {
   editorCss.show(true);
   editorCss.cssTabbedPane.setSelectedIndex(0);
  }


 }

 //Fine actionperformed

 public void funzione_salvaConNome()
  {
   //JOptionPane.showMessageDialog(null, "Prova x salva");
  //Originale:
  JFileChooser apri_box = new JFileChooser();
  apri_box.showSaveDialog(this);
  String file_in_cui_salvare = apri_box.getSelectedFile().getPath();


  String da_salvare = area_editing.getText();
  try {
  FileWriter salvataggio = new FileWriter(file_in_cui_salvare);
  //write(da_salvare, 0, area_editing.getText().length());
  salvataggio.write(da_salvare, 0, area_editing.getText().length());

  salvataggio.close();
      }
   catch(IOException e)
  {JOptionPane.showMessageDialog(null, e);}
  //int pino = area_editing.getText().length();     per provare come trovare
  //JOptionPane.showMessageDialog(null,""+ pino);          lunghezza del testo

  nomeFileCorrente = file_in_cui_salvare;
  statusbar.setText("Ready - "+nomeFileCorrente);

  }
  //Fine funzione_salvaConNome()

  public void funzione_salva()
  {
   //JOptionPane.showMessageDialog(null, "Prova x salva");
  //Originale:
    String file_in_cui_salvare;

  if(nomeFileCorrente.equalsIgnoreCase("untitled"))
  {
  JFileChooser apri_box = new JFileChooser();
  apri_box.showSaveDialog(this);
  file_in_cui_salvare = apri_box.getSelectedFile().getPath();
  }
  else
  {
   file_in_cui_salvare = nomeFileCorrente;
  }


  String da_salvare = area_editing.getText();
  try {
  FileWriter salvataggio = new FileWriter(file_in_cui_salvare);
  //write(da_salvare, 0, area_editing.getText().length());
  salvataggio.write(da_salvare, 0, area_editing.getText().length());

  salvataggio.close();
      }
   catch(IOException e)
  {JOptionPane.showMessageDialog(null, e);}
  //int pino = area_editing.getText().length();     per provare come trovare
  //JOptionPane.showMessageDialog(null,""+ pino);          lunghezza del testo

  nomeFileCorrente = file_in_cui_salvare;
  statusbar.setText("Ready - "+nomeFileCorrente);
  }
  //Fine funzione_salva()

  public void leggi()
  {
   //JOptionPane.showMessageDialog(null, "Prova x apri");

  JFileChooser apri_box = new JFileChooser();
  apri_box.showOpenDialog(this);
  String file_da_aprire = apri_box.getSelectedFile().getPath();
  try
  {
   FileReader lettore = new FileReader(file_da_aprire);
   int inByte = 0;
   String appoggio = "";
   do
    {
     try{
     inByte = lettore.read();
        }
     catch(IOException e)
     { JOptionPane.showMessageDialog(null, e);
     }

     if (inByte != -1)
     appoggio+=(char)inByte;
    }
    while (inByte != -1);

    //JOptionPane.showMessageDialog(null, appoggio); Prova x vedere se legge
    area_editing.setText(appoggio);

    try {
    lettore.close();
       }
     catch(IOException e)
     { JOptionPane.showMessageDialog(null, e);
     }
   }

  catch (FileNotFoundException e)
  {
   JOptionPane.showMessageDialog(null, e);
   }
   //Fine blocco principale TRY-CATCH

   nomeFileCorrente = file_da_aprire;
   statusbar.setText("Ready - "+nomeFileCorrente);


   }

   //Azioni del mouse
   public void mouseClicked(MouseEvent evento)
   {
   }

   public void mousePressed(MouseEvent evento)
   {
   }

   public void mouseReleased(MouseEvent evento)
   {
   }

   public void mouseExited(MouseEvent evento)
   {
    Object sorgente = evento.getSource();

    if ( (sorgente==apri_bot)||(sorgente==salva_bot)||(sorgente==nuovo_bot)||
         (sorgente==spazio_bot)||(sorgente==body_bot)||(sorgente==min_bot)||
         (sorgente==magg_bot)||(sorgente==agrave_bot)||(sorgente==egrave_bot)||
         (sorgente==igrave_bot)||(sorgente==ograve_bot)||(sorgente==ugrave_bot)||
         (sorgente==eacute_bot)||(sorgente==link_bot)||(sorgente==ogg_bot)||
         (sorgente==js_bot)||(sorgente==f_face_bot)||(sorgente==comm_bot)||
         (sorgente==br_bot)||(sorgente==table_bot)||(sorgente==img_bot)||
         (sorgente==center_bot)||(sorgente==ol_bot)||(sorgente==ul_bot)
         ||(sorgente==apriitem)||(sorgente==salvaitem)||(sorgente==esciitem)
         ||(sorgente==guidaitem)||(sorgente==aboutitem)||(sorgente==replitem)||
         (sorgente==win_rbm)||(sorgente==motif_rbm)||(sorgente==metal_rbm)||
         (sorgente==nuovoItem)||(sorgente==nuovoTxtItem)||(sorgente==salvaConNomeItem)||
         (sorgente==fontsMenu)||(sorgente==arialitem)||(sorgente==timesitem)||
         (sorgente==dialogitem)||(sorgente==courieritem)||
         (sorgente==caraSpecItem)||(sorgente==wrapCkbItem)||(sorgente==cssEditorItem))
       {statusbar.setText("Ready - "+nomeFileCorrente);}


     }

   public void mouseEntered(MouseEvent evento)
   {
    Object sorgente = evento.getSource();
    if (sorgente==apri_bot)
    {statusbar.setText("Apri un file esistente");}
    if (sorgente==salva_bot)
    {statusbar.setText("Salva il documento corrente");}
    if (sorgente==nuovo_bot)
    {statusbar.setText("Crea un nuovo documento HTML (per un nuovo documento di testo usare il menu 'File' oppure premere Ctrl+T)");}
    if (sorgente==spazio_bot)
    {statusbar.setText("Inserisce uno spazio forzato (non breaking space)");}
    if (sorgente==body_bot)
    {statusbar.setText("Inserisci il tag <BODY> completo di attributi");}
    if (sorgente==min_bot)
    {statusbar.setText("Inserisci il codice necessario per far scrivere il simbolo di minore (<)");}
    if (sorgente==magg_bot)
    {statusbar.setText("Inserisci il codice necessario per far scrivere il simbolo di maggiore (>)");}
    if (sorgente==agrave_bot)
    {statusbar.setText("Codice per inserire la a con accento grave");}
    if (sorgente==egrave_bot)
    {statusbar.setText("Codice per inserire la e con accento grave");}
    if (sorgente==igrave_bot)
    {statusbar.setText("Codice per inserire la i con accento grave");}
    if (sorgente==ograve_bot)
    {statusbar.setText("Codice per inserire la o con accento grave");}
    if (sorgente==ugrave_bot)
    {statusbar.setText("Codice per inserire la u con accento grave");}
    if (sorgente==eacute_bot)
    {statusbar.setText("Codice per inserire la e con accento acuto");}
    if (sorgente==link_bot)
    {statusbar.setText("Inserisci un link");}
    if (sorgente==ogg_bot)
    {statusbar.setText("Inserisci un oggetto (con <DIV>)");}
    if (sorgente==js_bot)
    {statusbar.setText("Inserisci uno script");}
    if (sorgente==f_face_bot)
    {statusbar.setText("Inserisce il tag per un nuovo font");}
    if (sorgente==comm_bot)
    {statusbar.setText("Inserisci un commento");}
    if (sorgente==br_bot)
    {statusbar.setText("Inserisci un ritorno a capo");}
    if (sorgente==table_bot)
    {statusbar.setText("Crea una tabella");}
    if (sorgente==img_bot)
    {statusbar.setText("Inserisci una immagine");}
    if (sorgente==center_bot)
    {statusbar.setText("Centra");}
    if (sorgente==ol_bot)
    {statusbar.setText("Crea liste");}
    if (sorgente==ul_bot)
    {statusbar.setText("Inserisci una riga orizzontale");}
    if (sorgente==apriitem)
    {statusbar.setText("Apri un file esistente");}
    if (sorgente==salvaitem)
    {statusbar.setText("Salva il documento corrente");}
    if (sorgente==esciitem)
    {statusbar.setText("Esci dal programma");}
    if (sorgente==guidaitem)
    {statusbar.setText("Visualizza la guida del programma");}
    if (sorgente==aboutitem)
    {statusbar.setText("Visualizza l'about box");}
    if (sorgente==replitem)
    {statusbar.setText("Lancia AlexMfM (J)Repeater");}
    if (sorgente==win_rbm)
    {statusbar.setText("Imposta il Look And Feel stile Windows");}
    if (sorgente==motif_rbm)
    {statusbar.setText("Imposta il Look And Feel stile Motif");}
    if (sorgente==metal_rbm)
    {statusbar.setText("Imposta il Look And Feel stile Metal");}
    if (sorgente==nuovoItem)
    {statusbar.setText("Crea un nuovo documento con la struttura base in HTML");}
    if (sorgente==nuovoTxtItem)
    {statusbar.setText("Crea un nuovo documento di testo (foglio pulito)");}
    if (sorgente==salvaConNomeItem)
    {statusbar.setText("Salva il documento con nome");}
    if (sorgente==fontsMenu)
    {statusbar.setText("Cambia il font (carattere di scrittura) nell'area di editing");}
    if (sorgente==arialitem)
    {statusbar.setText("Visualizza l'area di editing con il font 'Arial'");}
    if (sorgente==timesitem)
    {statusbar.setText("Visualizza l'area di editing con il font 'Times new roman'");}
    if (sorgente==dialogitem)
    {statusbar.setText("Visualizza l'area di editing con il font 'Dialog'");}
    if (sorgente==courieritem)
    {statusbar.setText("Visualizza l'area di editing con il font 'Courier new'");}
    if (sorgente==caraSpecItem)
    {statusbar.setText("Inserisce caratteri speciali tramite il loro codice");}
    if (sorgente==wrapCkbItem)
    {
     if(wrapCkbItem.isSelected())
     {
      statusbar.setText("Disattiva il ritorno a capo automatico");
     }
     else if(!wrapCkbItem.isSelected())
     {
      statusbar.setText("Attiva il ritorno a capo automatico");
     }
    }
    if (sorgente==cssEditorItem)
    {statusbar.setText("Lancia l'editor di fogli di stile by AlexMfM");}

   }

   //Funzione per creare un nuovo documento:
  public void crea_nuovo()
  {
   area_editing.setText("<html>\n<head>\n<title>\n\n</title>\n</head>\n\n\n\n</body>\n</html>");
   nomeFileCorrente = "Untitled";
   statusbar.setText("Ready - "+nomeFileCorrente);
  }

  JTextArea about_txtarea = new JTextArea("");
  JButton dispose_about_button = new JButton("Chiudi l'about box");
  JWindow about_frame;

  public void mostra_about()
  {
   //JFrame about_frame = new JFrame("About HTML (J)Editor Pro Ver. 4.2 with (J)Repeater 0.8");
   about_frame = new JWindow();
   dispose_about_button.setBackground(new Color(200,255,255));
   dispose_about_button.addActionListener(this);

   JPanel about_p_p = new JPanel();
   about_p_p.setLayout(new BorderLayout());
   String abt_txt = new String("HTML (J)Editor Pro - Ver 5.1 - by AlexMfM\n"+
   "(with AlexMfM (J)Repeater Ver 0.8 and AlexMfM (J)CssEditor 0.1)\n"+
   "This software is freeware;\nif you like it send an e-mail to:\n\n"+
   "alexmfm@tiscalinet.it\n\n"+
   "You use it at your own risk. I'm not responsible for\n"+
   "the troubles you may encounter using this\napplication.\n"+
   "For the latest version visit my site at:\n"+
   "http://web.tiscali.it/alexmfm\n\n"+
   "Ora in italiano:\n"+
   "Questo software e' freeware;\nse ti piace manda una e-mail a:\n\n"+
   "alexmfm@tiscalinet.it\n\n"+
   "Usate questo programma a vostro rischio e pericolo.\n"+
   "Non mi ritengo responsabile dei problemi\neventualmente causati"+
   "dall'utilizzo di\nquesto programma.\n"+
   "Per l'ultima versione visita il mio sito all'indirizzo:\n"+
   "http://web.tiscali.it/alexmfm\n\n");
   about_txtarea.setText(abt_txt);
   about_txtarea.setBackground(new Color(0,0,100,50));
   about_txtarea.setForeground(new Color(255,255,255));
   about_txtarea.setFont(new Font("Sans Serif", Font.BOLD, 10));
   about_txtarea.setAlignmentX(JTextArea.CENTER_ALIGNMENT);
   about_txtarea.setEditable(false);
   JScrollPane about_scrl = new JScrollPane(about_txtarea);
   about_p_p.add("Center", about_scrl);
   about_p_p.add("South", dispose_about_button);
   about_frame.setContentPane(about_p_p);
   //about_frame.resize(400,300);
   //Posiziono il frame al centro...
   Dimension dim_schermo = Toolkit.getDefaultToolkit().getScreenSize();
   about_frame.reshape((int)((dim_schermo.getWidth()/2)-(200)),(int)((dim_schermo.getHeight()/2)-200),
   400,400);
   about_frame.validate();
   about_frame.setVisible(true);


  }

  JTextArea guida_area = new JTextArea("");
  JTextArea tst_rap = new JTextArea("");
  JTextArea tst_body_area = new JTextArea("");
  JTextArea laf_area = new JTextArea("");
  JTextArea area_repli = new JTextArea("");
  JTextArea area_whatsnew = new JTextArea("");
  Color sfondo = new Color(0,0,100);
  Color primopiano = new Color(255,255,255);
  Font carattere = new Font("Sans Serif", Font.BOLD, 14);

  File roots[] = FileSystemView.getFileSystemView().getRoots();
  int i=0;
  int f=0;
  boolean instCons = false;
  String dirInstCons = new String("");
  String os = System.getProperty("os.name");
  String dirHH = new String("");
  String pathOS = new String("");



  public void mostra_guida()
  {
    /*Parte 1: preparare il percorso del programma di visione
      dei files della guida, nel caso l'utente abbia una
      macchina con sistema Win.
      Attenzione con jdk >=1.3 c'e' problema di gestione delle
      cartelle, quindi per prima cosa controllo la versione di
      java utilizzata, se 1.3 o maggiore mostro un avvertimento
      e la guida normale*/

   /*Adesso a seconda del sistema operativo imposto
     la stringa dirHH. Se Windows NT la imposto su
     "winnt", se e' Win98 la imposto su "Windows".
     Questa sara' la variabile con cui si fa il
     confronto quando si fa lo scan delle subdirectory.
   */

   //Stringa che conterra' la versione di java attuale. Servono solo
   //i primi 3 caratteri.
   String verBuffer = System.getProperty("java.version");
   String javaver = new String();
   //javaver.concat(verBuffer.charAt(0)).concat(verBuffer.charAt(1)).concat(verBuffer.charAt(2));
   javaver= javaver+verBuffer.charAt(0)+verBuffer.charAt(1)+verBuffer.charAt(2);
   if(javaver.equalsIgnoreCase("1.3"))
   {
    JOptionPane.showMessageDialog(null, "Attenzione!\nIl metodo di gestione della guida"+
    " mostra\ndei problemi con la versione 1.3.* della JVM.\n"+
    "La guida in formato .chm non potra' essere lanciata dall'interno\n"+
    "di HTML (J)Editor Pro 5. E' comunque avviabile con doppio click\n"+
    "dalla gestione risorse di Windows. Adesso verra' mostrata una\n"+
    "versione Java della guida stessa. Cerchero' (se dipende da me) di\n"+
    "porre rimedio alla situazione al piu' presto possibile.\n",
    "Problemi metodo di lancio guida con versione 1.3 di Java", JOptionPane.WARNING_MESSAGE);
     guidaNorm();

   }


   for(i=0;i<roots.length;i++)
    {
     if(roots[i].toString().equalsIgnoreCase("a:\\"))
      {i++;}
      //Oggetti di primo livello
     for(f=0;f<roots[i].listFiles().length;f++)
      {
       if(roots[i].listFiles()[f].toString().equalsIgnoreCase(roots[i].toString()+"html_editor_pro_5_1"))
        {
         int fs=0;

         for(fs=0;fs<roots[i].listFiles()[f].listFiles().length;fs++)
         {

          if(roots[i].listFiles()[f].listFiles()[fs].toString().equalsIgnoreCase(roots[i].listFiles()[f].toString()+"\\JEditor.chm"))
          {
           instCons = true;
           dirInstCons = roots[i].listFiles()[f].toString();
          }
         }//Fine for sugli oggetti di terzo livello della directory html_editor_pro_4_2

        }
       if(roots[i].listFiles()[f].toString().equalsIgnoreCase(roots[i].toString()+"winnt"))
       {pathOS=roots[i].listFiles()[f].toString();}
       if(roots[i].listFiles()[f].toString().equalsIgnoreCase(roots[i].toString()+"windows"))
       {pathOS=roots[i].listFiles()[f].toString();}
      }//Fine for oggetti secondo livello
     }//Fine for oggetti primo livello

     

    /*Parte 2: su quale sistema operativo ci troviamo?*/

    if(os.equalsIgnoreCase("Windows NT"))
    {dirHH="winnt";guidaWin(pathOS);return;}
    if(os.equalsIgnoreCase("Windows 98"))
    {dirHH="windows";guidaWin(pathOS);return;}

   guidaNorm();
   }//Fine mostraGuida()

   public void guidaNorm()
   {
   String testo_guida = new String("Guida all'utilizzo del programma.\n\n"+
   "Creare un documento:\n"+
   "Premere il tasto NEW oppure il menu File -> Nuovo e apparira'\nla struttura base per una pagina HTML.\n"+
   "Apparira' un input box per inserire il titolo della pagina.\n"+
   "Successivamente viene richiamata la funzione associata al tasto\n"+
   "BODY per immettere gli attributi necessari per impostare l'aspetto\n"+
   "della pagina. Alla pressione del tasto 'Conferma' nell'area di\n"+
   "editing sara' presente il codice minimo per visualizzare una pagina");

   String tst_txt = new String("Guida all'utilizzo del programma.\n\n"+
   "Per inserire un elemento con i tasti rapidi:\n"+
   "Posizionare il cursore nella posizione desiderata\ne premere il bottone "+
   "corrispondente all'elemento\ndesiderato.\nSe l'elemento serve per modificare elementi "+
   "oppure\nnecessita di essere riempito,gli spazi relativi\nvengono lasciati vuoti"+
   "e il cursore si sposta automaticamente\nall'interno delle virgolette del\n"+
   "primo attributo");
   String tst_body = new String("Guida all'utilizzo del programma.\n\n"+
   "Utilizzo dei pulsanti:\n"+
   "Quando viene utilizzato uno dei pulsanti che\n"+
   "immettono tag con piu' argomenti, si aprira'\n"+
   "una nuova finestra con tanti campi quanti sono\n"+
   "gli attributi supportati dallo stesso tag.\n"+
   "In questo caso e' possibile scegliere tramite\n"+
   "dei checkbox quali elementi visualizzare (nel \n"+
   "caso ad esempio del tag font, si puo' scegliere\n"+
   "di modificare il carattere, la dimensione e il\n"+
   "colore sia singolarmente che in qualsiasi combina-\n"+
   "zione). Se nessun checkbox verra' selezionato, alla\n"+
   "pressione del tasto 'Conferma' non verra' inserito\n"+
   "nessun codice, e il cursore rimarra' la' dove era \n"+
   "stato posizionato in precedenza");
   String tst_laf = new String("Look and Feel\n\n"+
   "Tramite il menu 'Look And Feel' e' possibile modificare l'aspetto\n"+
   "degli oggetti nelle finestre. E' possibile scegliere tra tre stili,\n"+
   "Motif (come nei sistemi unix), Windows (come nell'omonimo sistema) e\n"+
   "Metal (Look And Feel di Java). Quando viene avviato HTML (J)Editor\n"+
   "viene caricato il look Metal e scegliendo una delle voci e' possibile\n"+
   "modificare questo stile.\n");

   String tst_repli = new String("Guida all'utilizzo di 'AlexMfM's (J)Repeater\n\n"+
   "Per copiare un determinato numero di volte una porzione di testo\n"+
   "seguire le istruzioni qui sotto:\n"+
   "1) Selezionare la stringa da ripetere, quindi premere Ctrl-C per\n"+
   "   copiarlo;\n"+
   "2) Nella barra dei menu selezionare 'Tools' e quindi\n"+
   "   'AlexMfM's (J)Repeater\n"+
   "3) Premere Ctrl-V nell'apposita area per incollare il testo da\n"+
   "   replicare\n"+
   "4) Inserire il numero di copie da effettuare e premere il\n"+
   "   bottone 'Procedi'\n"+
   "5) Il testo replicato apparira' nel box a destra. A questo punto\n"+
   "   premete il bottone 'Invia a HTML (J)Editor' e il testo\n"+
   "   repicato verra' aggiunto nel vostro codice, subito dopo il\n"+
   "   cursore (la finestra di (J)Repeater viene chiuso\n   automaticamente).");

   String txt_whatsnew = new String("Novita' nella versione 5.1\n\n"+
   "- Create le scorciatoie di tastiera per i compiti piu' comuni\n"+
   "  come aprire e salvare files ecc...\n\n"+
   "- La funzione associata al menu 'Salva' e' stata modificata\n"+
   "  in modo da salvare il file aperto in precedenza nella sua posizione\n"+
   "  o aprire un dialog box nel caso il file sia creato da zero.\n"+
   "- Create le voci di menu 'Salva con nome...' che permette di\n"+
   "  specificare il percorso dove salvare il documento corrente\n"+
   "  e la voce 'Nuovo' che imita il comportamento del tasto NEW\n"+
   "- Adesso e' possibile navigare attraverso i menu anche con la \n"+
   "  tastiera tramite i caratteri sottolineati\n\n"+
   "- Dal menu 'Tools' e' possibile accedere ad un sottomenu\n"+
   "  che permette di visualizzare il testo contenuto nell'area\n"+
   "  di editing con quattro differenti tipi di font.\n"+
   "  Prossimamente mi occupero' anche di potervi far modificare la\n"+
   "  grandezza del carattere.\n\n"+
   "- Sistemate alcune piccole imperfezioni e/o errori di testo\n"+
   "  nella spiegazione dei comandi o della guida.\n"+
   "- Nella statusbar adesso oltre la solita scritta 'Ready' viene\n"+
   "  anche indicato il percorso del file corrente. Nel caso il file\n"+
   "  sia stato appena creato apparira' la scritta 'Untitled'.\n\n");



   JFrame guida_frame = new JFrame("Finestra della guida");
   JPanel guida_p_princ = new JPanel();
   guida_p_princ.setLayout(new BorderLayout());
   guida_area.setText(testo_guida);
   guida_area.setEditable(false);
   guida_area.setBackground(sfondo);
   guida_area.setForeground(primopiano);                       
   guida_area.setFont(carattere);
   tst_rap.setText(tst_txt);
   tst_rap.setEditable(false);
   tst_rap.setBackground(sfondo);
   tst_rap.setForeground(primopiano);
   tst_rap.setFont(carattere);
   tst_body_area.setText(tst_body);
   tst_body_area.setEditable(false);
   tst_body_area.setBackground(sfondo);
   tst_body_area.setForeground(primopiano);
   tst_body_area.setFont(carattere);
   area_repli.setText(tst_repli);
   area_repli.setEditable(false);
   area_repli.setBackground(sfondo);
   area_repli.setForeground(primopiano);
   area_repli.setFont(carattere);
   laf_area.setText(tst_laf);
   laf_area.setEditable(false);
   laf_area.setBackground(sfondo);
   laf_area.setForeground(primopiano);
   laf_area.setFont(carattere);
   area_whatsnew.setText(txt_whatsnew);
   area_whatsnew.setEditable(false);
   area_whatsnew.setBackground(sfondo);
   area_whatsnew.setForeground(primopiano);
   area_whatsnew.setFont(carattere);

   JScrollPane guida_scrl = new JScrollPane(guida_area);
   JScrollPane tst_scrl = new JScrollPane(tst_rap);
   JScrollPane body_scrl = new JScrollPane(tst_body_area);
   JScrollPane laf_scroll = new JScrollPane(laf_area);
   JScrollPane repli_scrl = new JScrollPane(area_repli);
   JScrollPane whatsnew_scrl = new JScrollPane(area_whatsnew);
   JTabbedPane pann_ling = new JTabbedPane();
   pann_ling.add("Nuovo documento", guida_scrl);
   pann_ling.add("Tasti rapidi", tst_scrl);
   pann_ling.add("Tag con attributi", body_scrl);
   pann_ling.add("Look And Feel", laf_scroll);
   pann_ling.add("(J)Repeater", repli_scrl);
   pann_ling.add("What's new", whatsnew_scrl);

   guida_p_princ.add("Center", pann_ling);
   guida_frame.setContentPane(guida_p_princ);
   //guida_frame.resize(540,300);
   Dimension dim_schermo = Toolkit.getDefaultToolkit().getScreenSize();
   guida_frame.reshape((int)((dim_schermo.getWidth()/2)-(600/2)),(int)((dim_schermo.getHeight()/2)-150),
   600,300);
   guida_frame.validate();
   guida_frame.setVisible(true);

   }//Fine guidaNorm()


  public void guidaWin(String path)
  {
   String urlGuida = new String(dirInstCons+"\\JEditor.chm");

   if(instCons==false)
    {
     String qualeGuida[] = {"Cerca il file...", "Guida in Java"};

     /*JOptionPane.showMessageDialog(null, "Scelta", false,
     "Attenzione: il programma non e' stato installato\n"+
     "nella directory consigliata. Impossibile trovare\n"+
     "automaticamente il file della guida.\n"+
     "Verra' aperto un FileChooser nel quale dovrete\n"+
     "selezionare il file 'JEditor.chm' che si trova nella\n"+
     "directory in cui avete installato questa applicazione.", qualeGuida);*/
     int sceltaGuida = JOptionPane.showOptionDialog(null,
      "Attenzione: il programma non e' stato installato\n"+
     "nella directory consigliata. Impossibile trovare\n"+
     "automaticamente il file della guida.\n"+
     "Se scegliete il bottone 'Cerca il file...'"+
     " verra' aperto\nun FileChooser nel quale dovrete\n"+
     "selezionare il file 'JEditor.chm' che si trova nella\n"+
     "directory in cui avete installato questa applicazione.\n"+
     "Se invece scegliete il pulsante 'Guida in Java' verra'\n"+
     "aperta una versione della guida realizzata in Java.",
     "Errore apertura files",0,JOptionPane.INFORMATION_MESSAGE, null, qualeGuida,
     qualeGuida[1]);
     
     if(sceltaGuida==0)
     {
     JFileChooser pathGuida = new JFileChooser();
     pathGuida.showOpenDialog(this);
     urlGuida = pathGuida.getSelectedFile().getPath();
     }
     else if(sceltaGuida==1)
     {
      guidaNorm();
      return;
     }


    }

    Runtime rtm = Runtime.getRuntime();
    try
     {
      rtm.exec(path+"\\hh.exe "+urlGuida);
     }
    catch(IOException ioe)
     {
      JOptionPane.showMessageDialog(null, "Problemuccio");
     }


  }//Fine guidaWin()

  JButton conf_bd = new JButton("Conferma");
  JButton ann_bd = new JButton("Annulla");
  //conf_bd.addActionListener(this);
  //ann_bd.addActionListener(this);
  JCheckBox bg_ck = new JCheckBox();
  JCheckBox back_ck = new JCheckBox();
  JCheckBox text_ck = new JCheckBox();
  JCheckBox link_ck = new JCheckBox();
  JCheckBox alink_ck = new JCheckBox();
  JCheckBox vlink_ck = new JCheckBox();
  JCheckBox bgprop_ck = new JCheckBox();

  JCheckBox body_ckb[] = new JCheckBox[]
   {bg_ck, back_ck, text_ck, link_ck, alink_ck, vlink_ck, bgprop_ck};
  String body_array_str[] = new String[]
   {"bgcolor=\"", "background=\"", "text=\"", "link=\"", "alink=\"",
    "vlink=\"", "bgproperties=\""};

  JLabel bg_label = new JLabel("Bgcolor:");
  JLabel back_label = new JLabel("Background (URL or path):");
  JLabel text_label = new JLabel("Text color:");
  JLabel link_label = new JLabel("Link color:");
  JLabel alink_label = new JLabel("Active link color:");
  JLabel vlink_label = new JLabel("Visited link color:");
  JLabel bgprop_label = new JLabel("Background properties:");

  JTextField  bg_field = new JTextField("");
  JTextField  back_field = new JTextField("");
  JTextField  text_field = new JTextField("");
  JTextField  link_field = new JTextField("");
  JTextField  alink_field = new JTextField("");
  JTextField  vlink_field = new JTextField("");
  JTextField  bgprop_field = new JTextField("");
  JTextField body_input_array[] = new JTextField[]
  {bg_field, back_field, text_field, link_field, alink_field,
   vlink_field, bgprop_field};

  JTextArea body_indic_area = new JTextArea("Scegliere tramite i checkbox quali elementi devono essere inseriti.\n"
  +"Inserire le nuove impostazioni del body e premere 'Conferma'");


  JFrame body_scelta = new JFrame("Impostare i parametri");



  void body_func()
  {
   


   JPanel body_principale = new JPanel();
   body_principale.setLayout(new BorderLayout());

   JPanel body_bottoni_pan = new JPanel();
   body_bottoni_pan.setLayout(new GridLayout(1,2));

   body_indic_area.setBackground(body_principale.getBackground());
   body_indic_area.setEditable(false);

   int ass_bg=0;
   while(ass_bg<7)
   {
    body_ckb[ass_bg].setBackground(body_principale.getBackground());
    ass_bg++;
   }

   JPanel body_landi = new JPanel(new GridLayout(7,2));


   body_landi.add(bg_label);
   body_landi.add(bg_field);
   body_landi.add(back_label);
   body_landi.add(back_field);
   body_landi.add(text_label);
   body_landi.add(text_field);
   body_landi.add(link_label);
   body_landi.add(link_field);
   body_landi.add(alink_label);
   body_landi.add(alink_field);
   body_landi.add(vlink_label);
   body_landi.add(vlink_field);
   body_landi.add(bgprop_label);
   body_landi.add(bgprop_field);
   body_bottoni_pan.add(conf_bd);
   body_bottoni_pan.add(ann_bd);

   Box box_princ = new Box(BoxLayout.X_AXIS);
   Box box_ck = new Box(BoxLayout.Y_AXIS);

   box_ck.add(bg_ck);
   box_ck.add(back_ck);
   box_ck.add(text_ck);
   box_ck.add(link_ck);
   box_ck.add(alink_ck);
   box_ck.add(vlink_ck);
   box_ck.add(bgprop_ck);

   box_princ.add(box_ck);
   box_princ.add(body_landi);


   body_principale.add("North", body_indic_area);
   body_principale.add("Center", box_princ);
   body_principale.add("South", body_bottoni_pan);


  //area_editing.insert("<body bgcolor=\"\" background=\"\" text=\"\" link=\"\" alink=\"\" vlink=\"\" bgproperties=\"fixed\">", cursore);
   body_scelta.setContentPane(body_principale);
   body_scelta.resize(380,240);
   body_scelta.move((int)((Toolkit.getDefaultToolkit().getScreenSize().getWidth()/2)-(380/2)),(int)((Toolkit.getDefaultToolkit().getScreenSize().getHeight()/2)-(240/2)));
   body_scelta.validate();
   body_scelta.setVisible(true);

  }

  JFrame imm_link_frame = new JFrame("Creazione di un link");
  JLabel lnk_labl = new JLabel("Indirizzo:");
  JTextField lnk_field = new JTextField(15);
  JLabel txt_link_labl = new JLabel("Inserire il testo del link:");
  JTextField txt_link_field = new JTextField(15);
  JLabel tar_link_labl = new JLabel("Inserire il target:");
  JTextField tar_link_field = new JTextField(15);
  JButton ins_link_conf = new JButton("Conferma");
  JButton ins_link_ann = new JButton("Annulla");
  int cursr;
  JCheckBox link_url_ck = new JCheckBox();
  JCheckBox link_targ_ck = new JCheckBox();
  JCheckBox link_text_ck = new JCheckBox();
  JCheckBox link_array[] = new JCheckBox[]{link_url_ck, link_targ_ck, link_text_ck};
  JTextArea link_indic_area = new JTextArea("Scegliere tramite i checkbox quali elementi devono essere inseriti.\n"
  +"Inserire le nuove impostazioni del link e premere 'Conferma'");

  String link_prop_nome[] = new String[]{"href=\"", "target=\""};
  JTextField array_link_input[] = new JTextField[]{lnk_field, tar_link_field, txt_link_field};

  void imm_link()
  {
   cursr=area_editing.getCaretPosition();

   JPanel imm_link_p_p = new JPanel();
   BoxLayout boxlay_link = new BoxLayout(imm_link_p_p, BoxLayout.X_AXIS);

   JPanel link_p_p = new JPanel(new BorderLayout());
   JPanel link_bot_p = new JPanel(new GridLayout(1,2));
   
   Box box_link_ck = new Box(BoxLayout.Y_AXIS);
   Box box_link_lbl = new Box(BoxLayout.Y_AXIS);
   Box box_link_field = new Box(BoxLayout.Y_AXIS);

   box_link_ck.add(link_url_ck);
   box_link_ck.add(link_targ_ck);
   box_link_ck.add(link_text_ck);
   box_link_lbl.add(lnk_labl);
   box_link_lbl.add(tar_link_labl);
   box_link_lbl.add(txt_link_labl);
   box_link_field.add(lnk_field);
   box_link_field.add(tar_link_field);
   box_link_field.add(txt_link_field);

   imm_link_p_p.add(box_link_ck);
   imm_link_p_p.add(box_link_lbl);
   imm_link_p_p.add(box_link_field);

   link_bot_p.add(ins_link_conf);
   link_bot_p.add(ins_link_ann);

   
   link_indic_area.setBackground(link_p_p.getBackground());
   link_indic_area.setEditable(false);

  link_url_ck.setBackground(link_p_p.getBackground());
  link_targ_ck.setBackground(link_p_p.getBackground());
  link_text_ck.setBackground(link_p_p.getBackground());

   link_p_p.add("Center", imm_link_p_p);
   link_p_p.add("South",link_bot_p);
   link_p_p.add("North", link_indic_area);

   imm_link_frame.setContentPane(link_p_p);
   imm_link_frame.resize(370,160);
   imm_link_frame.move((int)((Toolkit.getDefaultToolkit().getScreenSize().getWidth()/2)-(370/2)),(int)((Toolkit.getDefaultToolkit().getScreenSize().getHeight()/2)-(160/2)));
   imm_link_frame.setVisible(true);

  }

  JCheckBox ck_fontname = new JCheckBox();
  JCheckBox ck_fontcolor = new JCheckBox();
  JCheckBox ck_fontsize = new JCheckBox();
  JTextArea font_indic_area = new JTextArea("Scegliere tramite i checkbox quali elementi devono essere inseriti.\n"
  +"Inserire le nuove impostazioni del font e premere 'Conferma'");
  JFrame frame_font = new JFrame("Impostazione del font");
  JLabel fontname_labl = new JLabel("Nome del font:");
  JLabel fontcolor_labl = new JLabel("Colore:");
  JLabel fontsize_labl = new JLabel("Dimensione:");
  JTextField fontname_field = new JTextField("");
  JTextField fontcolor_field = new JTextField("");
  JTextField fontsize_field = new JTextField("");
  String array_prop_font_nome[] = new String[]{"face=\"", "color=\"", "size=\""};
  JTextField array_font_input[] = new JTextField[]{fontname_field, fontcolor_field, fontsize_field};
  JCheckBox array_ck[] = new JCheckBox[]{ck_fontname,ck_fontcolor, ck_fontsize};
  JButton ok_font_but = new JButton("Conferma");
  JButton an_font_but = new JButton("Annulla");



  void imposta_font()
  {
  //JOptionPane.showMessageDialog(null, ""+System.getProperties().toString());

   font_indic_area.setEditable(false);


   JPanel font_p_p = new JPanel();
   JPanel font_pan_bot = new JPanel();
   BorderLayout font_lay = new BorderLayout();
   font_pan_bot.setLayout(new GridLayout(1,2));
   font_pan_bot.add(ok_font_but);
   font_pan_bot.add(an_font_but);

   font_indic_area.setBackground(font_p_p.getBackground());
   ck_fontname.setBackground(font_p_p.getBackground());
   ck_fontcolor.setBackground(font_p_p.getBackground());
   ck_fontsize.setBackground(font_p_p.getBackground());

   Box box_opzioni_font = new Box(BoxLayout.X_AXIS);
   Box ck_box = new Box(BoxLayout.Y_AXIS);
   Box lbl_box = new Box(BoxLayout.Y_AXIS);
   Box field_box = new Box(BoxLayout.Y_AXIS);

   box_opzioni_font.add(fontname_labl);
   box_opzioni_font.add(fontname_field);
   box_opzioni_font.add(fontcolor_labl);
   box_opzioni_font.add(fontcolor_field);
   box_opzioni_font.add(fontsize_labl);
   box_opzioni_font.add(fontsize_field);

   ck_box.add(ck_fontname);
   ck_box.add(ck_fontcolor);
   ck_box.add(ck_fontsize);
   lbl_box.add(fontname_labl);
   lbl_box.add(fontcolor_labl);
   lbl_box.add(fontsize_labl);
   field_box.add(fontname_field);
   field_box.add(fontcolor_field);
   field_box.add(fontsize_field);

   box_opzioni_font.add(ck_box);
   box_opzioni_font.add(lbl_box);
   box_opzioni_font.add(field_box);



   font_p_p.setLayout(font_lay);

   font_p_p.add("North", font_indic_area);
   font_p_p.add("Center", box_opzioni_font);
   font_p_p.add("South", font_pan_bot);

   frame_font.setContentPane(font_p_p);
   frame_font.resize(400,150);
   frame_font.move((int)((Toolkit.getDefaultToolkit().getScreenSize().getWidth()/2)-(400/2)),(int)((Toolkit.getDefaultToolkit().getScreenSize().getHeight()/2)-(150/2)));
   frame_font.setVisible(true);

  }


  JCheckBox src_jcb = new JCheckBox();
  JCheckBox alt_jcb = new JCheckBox();
  JCheckBox width_jcb = new JCheckBox();
  JCheckBox height_jcb = new JCheckBox();
  JCheckBox array_img[] = new JCheckBox[]{src_jcb, alt_jcb, width_jcb, height_jcb};
  JTextArea img_indic_area = new JTextArea("Scegliere tramite i checkbox quali elementi devono essere inseriti.\n"
  +"Inserire le nuove impostazioni del font e premere 'Conferma'\n"+
  "(Il campo 'URL' e' indispensabile!)");
  JFrame frame_img = new JFrame("Inserimento di una immagine");
  JLabel img_src_labl = new JLabel("URL:");
  JLabel img_alt_labl = new JLabel("Testo alternativo:");
  JLabel img_hei_labl = new JLabel("Altezza:");
  JLabel img_wid_labl = new JLabel("Larghezza:");
  JTextField img_src_field = new JTextField("");
  JTextField img_alt_field = new JTextField("");
  JTextField img_hei_field = new JTextField("");
  JTextField img_wid_field = new JTextField("");
  String array_img_nome[] = new String[]{"src=\"", "alt=\"", "height=\"", "width=\""};
  JTextField array_img_input[] = new JTextField[]{img_src_field, img_alt_field, img_hei_field, img_wid_field};
  JButton ok_img_but = new JButton("Conferma");
  JButton an_img_but = new JButton("Annulla");




  void funz_img()
  {
   /*int cursore = area_editing.getCaretPosition();
   area_editing.insert("<img src=\"\" alt=\"\">", cursore);
   area_editing.grabFocus();
   int cp = area_editing.getCaretPosition();
   area_editing.setCaretPosition(cp-9);*/
   img_indic_area.setEditable(false);
   src_jcb.setSelected(true);

   JPanel img_p_p = new JPanel();
   JPanel img_pan_bot = new JPanel();
   BorderLayout img_lay = new BorderLayout();
   img_pan_bot.setLayout(new GridLayout(1,2));
   img_pan_bot.add(ok_img_but);
   img_pan_bot.add(an_img_but);

   img_indic_area.setBackground(img_p_p.getBackground());
   src_jcb.setBackground(img_p_p.getBackground());
   alt_jcb.setBackground(img_p_p.getBackground());
   height_jcb.setBackground(img_p_p.getBackground());
   width_jcb.setBackground(img_p_p.getBackground());

   Box box_opzioni_img = new Box(BoxLayout.X_AXIS);
   Box ck_img_box = new Box(BoxLayout.Y_AXIS);
   Box lbl_img_box = new Box(BoxLayout.Y_AXIS);
   Box field_img_box = new Box(BoxLayout.Y_AXIS);

   box_opzioni_img.add(img_src_labl);
   box_opzioni_img.add(img_src_field);
   box_opzioni_img.add(img_alt_labl);
   box_opzioni_img.add(img_alt_field);
   box_opzioni_img.add(img_hei_labl);
   box_opzioni_img.add(img_hei_field);
   box_opzioni_img.add(img_wid_labl);
   box_opzioni_img.add(img_wid_field);


   ck_img_box.add(src_jcb);
   ck_img_box.add(alt_jcb);
   ck_img_box.add(height_jcb);
   ck_img_box.add(width_jcb);
   lbl_img_box.add(img_src_labl);
   lbl_img_box.add(img_alt_labl);
   lbl_img_box.add(img_hei_labl);
   lbl_img_box.add(img_wid_labl);
   field_img_box.add(img_src_field);
   field_img_box.add(img_alt_field);
   field_img_box.add(img_hei_field);
   field_img_box.add(img_wid_field);

   box_opzioni_img.add(ck_img_box);
   box_opzioni_img.add(lbl_img_box);
   box_opzioni_img.add(field_img_box);



   img_p_p.setLayout(img_lay);

   img_p_p.add("North", img_indic_area);
   img_p_p.add("Center", box_opzioni_img);
   img_p_p.add("South", img_pan_bot);

   frame_img.setContentPane(img_p_p);
   frame_img.resize(400,200);
   frame_img.move((int)((Toolkit.getDefaultToolkit().getScreenSize().getWidth()/2)-(400/2)),(int)((Toolkit.getDefaultToolkit().getScreenSize().getHeight()/2)-(200/2)));
   frame_img.setVisible(true);


  }




  JFrame frame_tabella = new JFrame("Creazione di una tabella");
  JTextArea table_indic_area = new JTextArea("Immettere il numero di righe e colonne di cui deve essere\n"
  +"composta la tabella. Il valore del bordo se tralasciato o uguale a zero\n"+
  "non mostra il bordo. Tramite l'apposito checkbox e' possibile indicare anche\n"+
  "le dimensioni delle colonne");
  JLabel rows_lbl = new JLabel("Numero di righe:");
  JLabel cols_lbl = new JLabel("Numero di colonne:");
  JLabel bord_lbl = new JLabel("Spessore bordo:");
  JLabel dims_lbl = new JLabel("Impostare dimensioni delle singole colonne");
  JTextField rows_field = new JTextField();
  JTextField cols_field = new JTextField("");
  JTextField bord_field = new JTextField();
  JTextField array_larg_cols[] = new JTextField[]{};
  JCheckBox col_larg_ckb = new JCheckBox();
  JButton ok_tab_but = new JButton("Conferma");
  JButton an_tab_but = new JButton("Annulla");
  JPanel larg_panel = new JPanel(new GridLayout(1,10));
  //Questi sono i textfield per l'immissione larghezza...
  JTextField tab_tlg_1 = new JTextField(3);
  JTextField tab_tlg_2 = new JTextField(3);
  JTextField tab_tlg_3 = new JTextField(3);
  JTextField tab_tlg_4 = new JTextField(3);
  JTextField tab_tlg_5 = new JTextField(3);
  JTextField tab_tlg_6 = new JTextField(3);
  JTextField tab_tlg_7 = new JTextField(3);
  JTextField tab_tlg_8 = new JTextField(3);
  JTextField tab_tlg_9 = new JTextField(3);
  JTextField tab_tlg_10 = new JTextField(3);
  JTextField arr_tab_tgl[] = new JTextField[]{tab_tlg_1, tab_tlg_2,
  tab_tlg_3, tab_tlg_4, tab_tlg_5, tab_tlg_6, tab_tlg_7, tab_tlg_8,
  tab_tlg_9, tab_tlg_10};
  int p;


  void funz_tabella()
  {
   JPanel table_p_p = new JPanel(new BorderLayout());
   table_indic_area.setEditable(false);
   table_indic_area.setBackground(table_p_p.getBackground());
   JPanel tab_gruppo_centrale = new JPanel(new BorderLayout());
   JPanel tab_inp_panel = new JPanel(new GridLayout(3,2));
   JPanel tab_check_panel = new JPanel(new FlowLayout());
   //JPanel larg_panel = new JPanel(new GridLayout());
   JScrollPane scroll_larg = new JScrollPane(larg_panel);
   JPanel tab_but_pan = new JPanel(new GridLayout(1,2));
   //col_larg_ckb.setBackground(table_p_p.getBackground());

   for(p=0;p<10;p++)
   {
    larg_panel.add(arr_tab_tgl[p]);
    arr_tab_tgl[p].setEditable(false);
   }

   tab_inp_panel.add(rows_lbl);
   tab_inp_panel.add(rows_field);
   tab_inp_panel.add(cols_lbl);
   tab_inp_panel.add(cols_field);
   tab_inp_panel.add(bord_lbl);
   tab_inp_panel.add(bord_field);

   col_larg_ckb.setBackground(table_p_p.getBackground());
   tab_check_panel.add(col_larg_ckb);
   tab_check_panel.add(dims_lbl);

   tab_gruppo_centrale.add("North", tab_inp_panel);
   tab_gruppo_centrale.add("Center", tab_check_panel);
   tab_gruppo_centrale.add("South", scroll_larg);

   tab_but_pan.add(ok_tab_but);
   tab_but_pan.add(an_tab_but);


   table_p_p.add("North", table_indic_area);
   table_p_p.add("South", tab_but_pan);
   table_p_p.add("Center", tab_gruppo_centrale);

   frame_tabella.setContentPane(table_p_p);
   frame_tabella.setSize(450,300);
   frame_tabella.move((int)((Toolkit.getDefaultToolkit().getScreenSize().getWidth()/2)-(450/2)),(int)((Toolkit.getDefaultToolkit().getScreenSize().getHeight()/2)-(300/2)));
   frame_tabella.setVisible(true);

  }

  //Unico per tutte le liste
  String buffer_x_liste = new String("");
  JFrame frame_liste = new JFrame("Creazione di una lista");
  JLabel label_num_punti = new JLabel("Inserire numero di oggetti: ");
  JLabel label_stili = new JLabel("Impostazione di uno stile per la lista");
  JTextField tfield_num_punti = new JTextField("0",20);
  String string_stili[] = new String[]{"Disco", "Cerchio", "Quadrato", "Decimale",
   "Num. romani (minuscolo)", "Num. romani (maiuscolo)", "Lettere (minuscolo)",
   "Lettere (maiuscolo)", "Immagine..."};
  JComboBox combo_stile_liste = new JComboBox(string_stili);
  JCheckBox cb_stili = new JCheckBox();
  JButton ok_liste_but = new JButton("Conferma");
  JButton an_liste_but = new JButton("Annulla");
  JPanel liste_p_p;


  public void funz_liste()
  {
   liste_p_p = new JPanel(new GridLayout(4,1));

   //Evidenzia il numero di default per poter semplicemente
   //scrivere il nuovo numero senza dover cancellare quello
   //di default
   tfield_num_punti.setSelectionStart(0);
   tfield_num_punti.setSelectionEnd(tfield_num_punti.getText().length());

   JPanel elem_panel = new JPanel();
   elem_panel.add(label_num_punti);
   elem_panel.add(tfield_num_punti);
   liste_p_p.add(elem_panel);

   if(cb_stili.isSelected()==false)
   {combo_stile_liste.setEnabled(false);}
   if(cb_stili.isSelected()==true)
   {combo_stile_liste.setEnabled(true);}

   cb_stili.addActionListener(this);

   JPanel stile_panel = new JPanel();
   stile_panel.add(cb_stili);
   stile_panel.add(label_stili);
   stile_panel.add(combo_stile_liste);
   liste_p_p.add(stile_panel);

   JTextArea ta_stili = new JTextArea("Attenzione: per impostare i vari tipi di stili"+
   " si fa ricorso ai fogli di stile (CSS).\n"+
   "I browser piu' datati potrebbero avere delle difficolta' "+
   "nell'interpretarli, ma in tal\ncaso dovrebbe essere usato "+
   "automaticamente il simbolo di default previsto dal browser.");
   ta_stili.setEditable(false);
   ta_stili.setBackground(liste_p_p.getBackground());
   liste_p_p.add(ta_stili);

   ok_liste_but.addActionListener(this);
   an_liste_but.addActionListener(this);

   JPanel bottoni_liste_panel = new JPanel(new GridLayout(1,2));
   bottoni_liste_panel.add(ok_liste_but);
   bottoni_liste_panel.add(an_liste_but);
   liste_p_p.add(bottoni_liste_panel);



   frame_liste.setContentPane(liste_p_p);
   frame_liste.setSize(500,250);
   frame_liste.move((int)((Toolkit.getDefaultToolkit().getScreenSize().getWidth()/2)-(450/2)),(int)((Toolkit.getDefaultToolkit().getScreenSize().getHeight()/2)-(300/2)));
   frame_liste.setVisible(true);
  }

  String caraSpec[] = new String[]{"#","$","%","&","@","|","~","","","","",
  "","","","","","","","","","","","","","","",""};
  String caraSpecCodif[] = new String[]{"&#35;","&#36;","&#37;","&amp;","&#64;","&#124","&#126","&cent;","&pound;","&euro;",
  "&sect;","&uml;","&copy;","&laquo;","&raquo;","&not;","&reg;","&micro;",
  "&plusmn;","&para;","&ordm;","&frac14;","&frac12;","&frac34;","&szlig;","&deg;","&euro;"};


  public void funzioneCaraSpec()
  {
   String daCodifCaraSpec = JOptionPane.showInputDialog(null, "Inserire il carattere speciale da codificare\n"+
   "e cliccare su ok", "Codifica di caratteri speciali", JOptionPane.INFORMATION_MESSAGE);
   //JOptionPane.showMessageDialog(null, "Hai inserito"+daCodifCaraSpec);
   //JOptionPane.showMessageDialog(null,"Codice carattere "+daCodifCaraSpec.hashCode());

   int curs = area_editing.getCaretPosition();
   int a=0;
   boolean trovato = false;
   /*Questo va specificato da solo, perche' pare non riconoscere
     il carattere nell'array, ma lo riconosce se si prende il
     suo hashCode*/
   if(daCodifCaraSpec.hashCode()==8364)
     {
      int caraSpecInserEuro = JOptionPane.showConfirmDialog(null,
     "Trovata corrispondenza per '"+daCodifCaraSpec+"'.\n"+
     "Il codice da inserire e': &euro;\nInserisco?", "Esito della ricerca positivo",
     JOptionPane.YES_NO_OPTION,JOptionPane.INFORMATION_MESSAGE);
      //JOptionPane.showMessageDialog(null,"Codice carattere"+daCodifCaraSpec.hashCode());
     trovato=true;
     if(caraSpecInserEuro==JOptionPane.YES_OPTION)
     {
      area_editing.insert("&euro;", curs);
      return;
     }
     else if(caraSpecInserEuro==JOptionPane.NO_OPTION)
     {
      return;
     }
     }

   for(a=0;a<caraSpec.length;a++)
   {
    if(daCodifCaraSpec.equalsIgnoreCase(caraSpec[a]))
    {
     int caraSpecInser = JOptionPane.showConfirmDialog(null,
     "Trovata corrispondenza per '"+daCodifCaraSpec+"'.\n"+
     "Il codice da inserire e': "+caraSpecCodif[a]+"\nInserisco?", "Esito della ricerca positivo",
     JOptionPane.YES_NO_OPTION,JOptionPane.INFORMATION_MESSAGE);
      //JOptionPane.showMessageDialog(null,"Codice carattere"+daCodifCaraSpec.hashCode());
     trovato=true;
     if(caraSpecInser==JOptionPane.YES_OPTION)
     {
      area_editing.insert(caraSpecCodif[a], curs);
     }
     else if(caraSpecInser==JOptionPane.NO_OPTION)
     {
      return;
     }
     return;
     
    }
   }
   if(trovato==false)
    {
     JOptionPane.showMessageDialog(null, "Non e' stata trovata nessuna corrispondenza\nper il carattere speciale immesso.\n",
     "Esito della ricerca negativo", JOptionPane.ERROR_MESSAGE);
    }
    


  }
  
  static String txt = new String();
  public static String incolla()
  {
   Transferable da_incollare = Cboard.clip.getContents(Cboard.clip);


    try{
    txt = (String)da_incollare.getTransferData(DataFlavor.stringFlavor);
    int carpos = area_editing.getCaretPosition();
    area_editing.insert(txt, carpos);
    }
    catch (Exception e)
    {}

   return txt;

  }



  public void lostOwnership(Clipboard clip, Transferable contents)
  {}

}
