package html_editor_pro_5_1;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.awt.datatransfer.*;

public class Repl extends JFrame implements ActionListener, ClipboardOwner
{

//Elementi del menu
JMenuItem esciitem = new JMenuItem("Esci");
JMenuItem resetitem = new JMenuItem("Resetta tutto");
JMenuItem guidaitem = new JMenuItem("Guida");
JMenuItem aboutitem = new JMenuItem("About...");
//Label riferita alla textarea ins_cod
JLabel label_ins_cod = new JLabel("Testo da replicare");
//Textarea di inserimento codice
JTextArea ins_cod =new JTextArea(10,20);
//Label riferita all'inserimento delle copie
JLabel label_ins_copie = new JLabel("Numero di repliche:");
//Textfield che prende l'input delle copie
JTextField ins_copie = new JTextField(4);
//Bottone "Procedi"
JButton but_procedi = new JButton("Procedi!");
//Textarea con i risultati
//JTextArea risultato = new JTextArea(10,10);
JTextArea risultato = new JTextArea(50,35);
//Label con istruzioni per copia-incolla
JTextArea etich_c = new JTextArea(4,10);
JTextArea etich_i = new JTextArea(4,10);






//Lo scrollpane che serve per far scrollare risultato
JScrollPane scrl = new JScrollPane(risultato);
//Scrollpane per l'inserimento del codice
JScrollPane scrl_ins = new JScrollPane(ins_cod);
//Jbutton per salvare il risultato
JButton salva_but = new JButton("Invia a HTML (J)Editor");
//JButton per resettare i campi
JButton reset_button = new JButton("Resetta tutto");

//Pannelli
JPanel pannello_principale = new JPanel();
JPanel pannello_menu = new JPanel();
JPanel input_panel =new JPanel();
JPanel output_panel =new JPanel();
JPanel copy_panel = new JPanel();
JPanel over_input = new JPanel();

JMenuBar barra_menu = new JMenuBar();

static LookAndFeel repl_feel;



  public Repl(String titolo)
  {
   super(titolo);
    //Layout dei pannelli
    pannello_principale.setLayout(new BorderLayout());
    input_panel.setLayout(new GridLayout(3,1));
    output_panel.setLayout(new GridLayout(1,1));
    copy_panel.setLayout(new GridLayout(4,2));
    over_input.setLayout(new BorderLayout());


    over_input.add("North",label_ins_cod);
    over_input.add("Center", input_panel);
    output_panel.add(scrl);

    copy_panel.add(label_ins_copie);
    copy_panel.add(ins_copie);
    copy_panel.add(but_procedi);
    copy_panel.add(reset_button);
    etich_c.setText("Per copiare: Ctrl-C");
    etich_i.setText("Per incollare: Ctrl-V");
    etich_c.setEditable(false);
    etich_i.setEditable(false);
    etich_c.setBackground(new Color(200,200,255));
    etich_i.setBackground(new Color(200,200,255));
    copy_panel.add(etich_c);
    copy_panel.add(etich_i);

    input_panel.add(scrl_ins);
    input_panel.add(copy_panel);



    //Componenti menubar
    pannello_menu.setBackground(new Color(10,200, 10));
    JMenu file = new JMenu("File");
    JMenu modifica = new JMenu("Modifica");
    JMenu guida = new JMenu("Help");
    file.add(esciitem);
    modifica.add(resetitem);
    guida.add(guidaitem);
    guida.add(aboutitem);
    barra_menu.add(file);
    barra_menu.add(modifica);
    barra_menu.add(guida);
    pannello_menu.add(barra_menu);


    pannello_principale.add("North", barra_menu);
    pannello_principale.add("West", over_input);
    pannello_principale.add("East", output_panel);
    pannello_principale.add("South",salva_but);

    //Action Listener
    but_procedi.addActionListener(this);
    reset_button.addActionListener(this);
    salva_but.addActionListener(this);
    esciitem.addActionListener(this);
    guidaitem.addActionListener(this);
    aboutitem.addActionListener(this);
    resetitem.addActionListener(this);
   

    //Imposto il content pane
    setContentPane(pannello_principale);
    pannello_principale.setVisible(true);



   }

  public static void main (String[] args)
  {
   JFrame rpl = new Repl("AlexMfM's (J)Repeater for (J)Editor Ver 5.1 - Build 79");
   WindowListener wl = new WindowAdapter()
   

   {public void windowClosing(WindowEvent e)
   {System.exit(0);}};
   rpl.addWindowListener(wl);
   rpl.setSize(700,500);
   rpl.setVisible(true);


   }

  String cod_risultante = new String("");


  public void actionPerformed(ActionEvent evento)
 {
  Object sorgente = evento.getSource();

  if (sorgente==but_procedi)
   {
    cod_risultante="";
    risultato.setText("");
    Integer ncopie = new Integer(ins_copie.getText());
    int ncopie_int = ncopie.intValue();
    String da_copiare = new String(ins_cod.getText());
    int i=0;

    for(i=0;i<ncopie_int;i++)
    {
     cod_risultante+= da_copiare+"\n";
    }

    risultato.setText(cod_risultante);

    
   }

   if(sorgente==esciitem)
  {
   int decisione;
   decisione = JOptionPane.showConfirmDialog(null,
   "Invio il testo replicato a HTML (J)Editor prima di chiudere?",
   "Trasferimento testo?", JOptionPane.YES_NO_CANCEL_OPTION);

   if (decisione==JOptionPane.YES_OPTION)
   { funzione_salva();
     System.exit(0);
   }
   else if (decisione==JOptionPane.NO_OPTION)
   {
   System.exit(0);
   }
   else if (decisione==JOptionPane.CANCEL_OPTION)
   {
   return;
   }

  }

  if (sorgente==salva_but)
  {

  funzione_salva();
  }

  if(sorgente==guidaitem)
  {
   JOptionPane.showMessageDialog(null, "Beh, c'e' poco da dire...\n"
   +"Inserite il testo da replicare,\ninserite il numero di copie da effetturare\n"
   +"e premete 'Procedi'");
  }

  if(sorgente==aboutitem)
  {
   JOptionPane.showMessageDialog(null,"AlexMfM's (J)Repeater ver 0.8\n"+
   "Programma coniglioware! Ovvero voi mettete una stringa di testo\n"+
   "da scrivere piu' volte, indicate quanti cuccioli di quella stringa\n"+
   "desiderate, e per magia, questa si moltiplichera' con la rapidita'\n"+
   "tipica dei simpatici animaletti dai lunghi orecchi! (o orecchie?)",
   "AlexMfM's (J)Repeater for HTML (J)Editor 0.8", JOptionPane.DEFAULT_OPTION);
  }


  if((sorgente==resetitem)||(sorgente==reset_button))
  {
   ins_cod.setText("");
   ins_copie.setText("");
   risultato.setText("");
   }

  }

  Clipboard appunti = new Clipboard("");


    public void funzione_salva()
  {
   //JOptionPane.showMessageDialog(null, "Prova x salva");
   //String buffer_dati = cod_risultante;
   String da_copiare = cod_risultante;
   StringSelection trans = new StringSelection(da_copiare);
   Cboard.clip.setContents(trans, this);
   Editor.incolla();
   this.hide();
   //JOptionPane.showMessageDialog(null, Cboard.clip.toString());
  }

  public void lostOwnership(Clipboard clip, Transferable contents)
  {}



}


